VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

Private m_strName As String
Private m_lngAttributes As Long
Private m_varTimeCreated As Variant
Private m_varTimeLastAccessed As Variant
Private m_varTimeLastWritten As Variant
Private m_lngSize As Long

Public Property Get Name() As String
'
' Returns the file's name
'
    Name = m_strName
End Property

Friend Property Let Name(Value As String)
'
' sets the file's name; Read Only externally
'
    m_strName = Value
End Property

Public Property Get Attributes() As Long
'
' gets the file's attributes as Long
'
    Attributes = m_lngAttributes
End Property

Friend Property Let Attributes(Value As Long)
'
' sets the file's attributes; Read Only externally
'
    m_lngAttributes = Value
End Property

Public Property Get AttributesString() As String
'
' gets the file's attributes as a concatenated String
'
Dim strOut As String
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_READONLY Then
        strOut = strOut & "R"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_HIDDEN Then
        strOut = strOut & "H"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_SYSTEM Then
        strOut = strOut & "S"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_DIRECTORY Then
        strOut = strOut & "D"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_ARCHIVE Then
        strOut = strOut & "A"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_NORMAL Then
        strOut = strOut & "N"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_TEMPORARY Then
        strOut = strOut & "T"
    End If
    If m_lngAttributes And ITL_FILE_ATTRIBUTE_COMPRESSED Then
        strOut = strOut & "C"
    End If
    AttributesString = strOut
End Property

Public Property Get TimeCreated() As Variant
'
' gets the file's creation Date Time stamp
'
    TimeCreated = m_varTimeCreated
End Property

Friend Property Let TimeCreated(Value As Variant)
'
' sets the file's creation Date Time stamp; readonly externally
'
    m_varTimeCreated = Value
End Property

Public Property Get TimeLastAccessed() As Variant
'
' gets the file's last access Date Time stamp
'
    TimeLastAccessed = m_varTimeLastAccessed
End Property

Friend Property Let TimeLastAccessed(Value As Variant)
'
' sets the file's last access Date Time stamp; readonly externally
'
    m_varTimeLastAccessed = Value
End Property

Public Property Get TimeLastWritten() As Variant
'
' gets the file's last written Date Time stamp;
'
    TimeLastWritten = m_varTimeLastWritten
End Property

Friend Property Let TimeLastWritten(Value As Variant)
'
' sets the file's last written Time stamp; readonly externally
'
    m_varTimeLastWritten = Value
End Property

Public Property Get Size() As Long
'
' gets the file's size
'
    Size = m_lngSize
End Property

Friend Property Let Size(Value As Long)
'
' sets the file's size; readonly externally
'
    m_lngSize = Value
End Property




