VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Files"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

'
'  Collection class to hold all files found in a FTP search of a site
'
Private m_colFiles As Collection

Friend Function Add(pWin32FileData As WIN32_FIND_DATA) As File
'
'  Creates a File object represented by the WIN32_FIND_DATA structure
'  and adds it to the internal collection
'
On Error GoTo ErrHandler
Dim clsFile As File
    
    Set clsFile = New File
    
    With pWin32FileData
        clsFile.Name = fTrimNull(.cFileName)
        clsFile.Attributes = .dwFileAttributes
        clsFile.Size = ((.nFileSizeHigh * (MAXDWORD + 1)) + .nFileSizeLow)
        clsFile.TimeCreated = fGetFileTime(pWin32FileData, 1)
        clsFile.TimeLastAccessed = fGetFileTime(pWin32FileData, 2)
        clsFile.TimeLastWritten = fGetFileTime(pWin32FileData, 3)
    End With
    
    
    m_colFiles.Add clsFile, clsFile.Name
    Set Add = clsFile
    Set clsFile = Nothing
    
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

Friend Sub ClearCollection()
'
'   Resets the collection
'
    Set m_colFiles = New Collection
End Sub

Public Property Get Item(index As Variant) As File
'
'   returns a particular item from the internal collection
'
  Set Item = m_colFiles(index)
End Property

Public Property Get Count() As Long
'
'   returns the count of number of items in the internal collection
'
    Count = m_colFiles.Count
End Property

Friend Sub Remove(index As Variant)
'
'   removes a specified item from the collection
'
On Error GoTo ErrHandler
    m_colFiles.Remove index

ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Sub

Public Function Enumerate() As IUnknown
Attribute Enumerate.VB_UserMemId = -4
Attribute Enumerate.VB_MemberFlags = "40"
'
'   allows caller to issue a 'For Each' call on the collection
'
    Set Enumerate = m_colFiles.[_NewEnum]
End Function

Private Sub Class_Initialize()
    Set m_colFiles = New Collection
End Sub

Private Sub Class_Terminate()
    Set m_colFiles = Nothing
End Sub



