VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Folders"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

'
'  Collection class to hold all folders found in a FTP search of a site
'
Private m_colFolders As Collection

Friend Function Add(ByVal Path As String) As Folder
'
'   Creates a Folder object represented by the path passed in
'   and adds it to the internal collection
'
On Error GoTo ErrHandler
    Dim clsFolder As Folder
    
    Set clsFolder = New Folder
    clsFolder.Path = Path

    m_colFolders.Add clsFolder, Path
    Set Add = clsFolder
    Set clsFolder = Nothing
    
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

Friend Sub ClearCollection()
'
' Resets the collection
'
    Set m_colFolders = New Collection
End Sub

Public Property Get Item(index As Variant) As Folder
'
'   Returns the item at the specified location from the collection
'
  Set Item = m_colFolders(index)
End Property

Public Property Get Count() As Integer
'
'   Returns the count of items in the internal collection
'
    Count = m_colFolders.Count
End Property

Friend Sub Remove(index As Variant)
'
'   Removes the item at the specified location
'
On Error GoTo ErrHandler
    m_colFolders.Remove index

ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Sub

Public Function Enumerate() As IUnknown
Attribute Enumerate.VB_UserMemId = -4
Attribute Enumerate.VB_MemberFlags = "40"
'
'   Allows caller to issue a 'For Each' call on the collection
'
    Set Enumerate = m_colFolders.[_NewEnum]
End Function

Private Sub Class_Initialize()
    Set m_colFolders = New Collection
End Sub

Private Sub Class_Terminate()
    Set m_colFolders = Nothing
End Sub


