VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HTTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

Public Event StatusChanged(ByVal Status As String)
Public Event FileProgress(ByVal Factor As Single)
Public Event Redirect(ByVal RequestedURL As String, ByVal RedirectedURL As String, Cancel As Boolean)

Public Enum itlPortType
    ITL_INTERNET_DEFAULT_FTP_PORT = 21                  '  default for FTP servers
    ITL_INTERNET_DEFAULT_GOPHER_PORT = 70            '      "       "  gopher  "
    ITL_INTERNET_DEFAULT_HTTP_PORT = 80                '      "       "  HTTP   "
    ITL_INTERNET_DEFAULT_HTTPS_PORT = 443             '      "       "  HTTPS  "
End Enum

Public Enum itlMaxLengths
    ITL_INTERNET_MAX_HOST_NAME_LENGTH = 256
    ITL_INTERNET_MAX_USER_NAME_LENGTH = 128
    ITL_INTERNET_MAX_PASSWORD_LENGTH = 128
    ITL_INTERNET_MAX_PORT_NUMBER_LENGTH = 5          '  ' // INTERNET_PORT is unsigned short
    ITL_INTERNET_MAX_PORT_NUMBER_VALUE = 65535      '  ' // maximum unsigned short value
    ITL_INTERNET_MAX_PATH_LENGTH = 2048
    ITL_INTERNET_MAX_SCHEME_LENGTH = 32               '  ' // longest protocol name length
    ITL_INTERNET_MAX_URL_LENGTH = (ITL_INTERNET_MAX_SCHEME_LENGTH + 3 + ITL_INTERNET_MAX_PATH_LENGTH)
                                     '  ' // (INTERNET_MAX_SCHEME_LENGTH + sizeof(":'  ' //") + INTERNET_MAX_PATH_LENGTH)
End Enum

Public Enum itlConnectFlags
    ITL_INTERNET_FLAG_CACHE_IF_NET_FAIL = &H10000    ' // return cache file if net request fails
    ITL_INTERNET_FLAG_HYPERLINK = &H400                     ' // asking wininet to do hyperlinking semantic which works right for scripts
    ITL_INTERNET_FLAG_IGNORE_CERT_CN_INVALID = &H1000       '// bad common name in X509 Cert.
    ITL_INTERNET_FLAG_IGNORE_CERT_DATE_INVALID = &H2000     ' // expired X509 Cert.
    ITL_INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP = &H8000      '// ex: https:// to http://
    ITL_INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS = &H4000     ' // ex: http:// to https://
    ITL_INTERNET_FLAG_KEEP_CONNECTION = &H400000       ' // use keep-alive semantics
    ITL_INTERNET_FLAG_NEED_FILE = &H10               ' // need a file for this request
    ITL_INTERNET_FLAG_NO_AUTH = &H40000              ' // no automatic authentication handling
    ITL_INTERNET_FLAG_NO_AUTO_REDIRECT = &H200000  ' // don't handle redirections automatically
    ITL_INTERNET_FLAG_NO_CACHE_WRITE = &H4000000    ' // don't write this item to the cache
    ITL_INTERNET_FLAG_NO_COOKIES = &H80000        ' // no automatic cookie handling
    ITL_INTERNET_FLAG_NO_UI = &H200                     ' // no cookie popup
    ITL_INTERNET_FLAG_PRAGMA_NOCACHE = &H100         '  ' // asking wininet to add "pragma: no-cache"
    ITL_INTERNET_FLAG_RELOAD = &H80000000          '// retrieve the original item
    ITL_INTERNET_FLAG_RESYNCHRONIZE = &H800      ' // asking wininet to update an item if it is newer
    ITL_INTERNET_FLAG_SECURE = &H800000              ' // use PCT/SSL if applicable (HTTP)
    ITL_INTERNET_FLAG_PASSIVE = &H8000000                  ' // used for FTP connections
    ITL_INTERNET_FLAG_RAW_DATA = &H40000000          '// FTP/gopher find: receive the item as raw (structured) data
    ITL_INTERNET_FLAG_EXISTING_CONNECT = &H20000000

    ITL_INTERNET_FLAG_READ_PREFETCH = &H100000       ''  ' // do background read prefetch
    ITL_INTERNET_FLAG_DONT_CACHE = ITL_INTERNET_FLAG_NO_CACHE_WRITE
    ITL_INTERNET_FLAG_MAKE_PERSISTENT = &H2000000    '  ' // make this item persistent in cache
    ITL_INTERNET_FLAG_CACHE_ASYNC = &H80             '  ' // ok to perform lazy cache-write
    ITL_INTERNET_FLAG_FORMS_SUBMIT = &H40            '  ' // this is a forms submit
    ITL_INTERNET_FLAG_MUST_CACHE_REQUEST = ITL_INTERNET_FLAG_NEED_FILE
    ITL_HTTP_QUERY_FLAG_NUMBER = &H20000000
End Enum

Public Enum itlOpenFlags
    ITL_INTERNET_FLAG_ASYNC = &H10000000
    ITL_INTERNET_FLAG_FROM_CACHE = &H1000000         '  ' // use offline semantics
    ITL_INTERNET_FLAG_OFFLINE = ITL_INTERNET_FLAG_FROM_CACHE
End Enum

Public Enum itlHTTPStatus
     ITL_HTTP_STATUS_CONTINUE = 100           ' // OK to continue with request
     ITL_HTTP_STATUS_SWITCH_PROTOCOLS = 101   ' // server has switched protocols in upgrade header
     ITL_HTTP_STATUS_OK = 200                 ' // request completed
     ITL_HTTP_STATUS_CREATED = 201            ' // object created, reason = new URI
     ITL_HTTP_STATUS_ACCEPTED = 202           ' // async completion (TBS)
     ITL_HTTP_STATUS_PARTIAL = 203            ' // partial completion
     ITL_HTTP_STATUS_NO_CONTENT = 204         ' // no info to return
     ITL_HTTP_STATUS_RESET_CONTENT = 205      ' // request completed, but clear form
     ITL_HTTP_STATUS_PARTIAL_CONTENT = 206    ' // partial GET furfilled
     ITL_HTTP_STATUS_AMBIGUOUS = 300          ' // server couldn't decide what to return
     ITL_HTTP_STATUS_MOVED = 301              ' // object permanently moved
     ITL_HTTP_STATUS_REDIRECT = 302           ' // object temporarily moved
     ITL_HTTP_STATUS_REDIRECT_METHOD = 303    ' // redirection w/ new access method
     ITL_HTTP_STATUS_NOT_MODIFIED = 304       ' // if-modified-since was not modified
     ITL_HTTP_STATUS_USE_PROXY = 305          ' // redirection to proxy, location header specifies proxy to use
     ITL_HTTP_STATUS_REDIRECT_KEEP_VERB = 307 ' // HTTP/1.1: keep same verb
     ITL_HTTP_STATUS_BAD_REQUEST = 400        ' // invalid syntax
     ITL_HTTP_STATUS_DENIED = 401             ' // access denied
     ITL_HTTP_STATUS_PAYMENT_REQ = 402        ' // payment required
     ITL_HTTP_STATUS_FORBIDDEN = 403          ' // request forbidden
     ITL_HTTP_STATUS_NOT_FOUND = 404          ' // object not found
     ITL_HTTP_STATUS_BAD_METHOD = 405         ' // method is not allowed
     ITL_HTTP_STATUS_NONE_ACCEPTABLE = 406    ' // no response acceptable to client found
     ITL_HTTP_STATUS_PROXY_AUTH_REQ = 407     ' // proxy authentication required
     ITL_HTTP_STATUS_REQUEST_TIMEOUT = 408    ' // server timed out waiting for request
     ITL_HTTP_STATUS_CONFLICT = 409           ' // user should resubmit with more info
     ITL_HTTP_STATUS_GONE = 410               ' // the resource is no longer available
     ITL_HTTP_STATUS_LENGTH_REQUIRED = 411    ' // the server refused to accept request w/o a length
     ITL_HTTP_STATUS_PRECOND_FAILED = 412     ' // precondition given in request failed
     ITL_HTTP_STATUS_REQUEST_TOO_LARGE = 413  ' // request entity was too large
     ITL_HTTP_STATUS_URI_TOO_LONG = 414       ' // request URI too long
     ITL_HTTP_STATUS_UNSUPPORTED_MEDIA = 415  ' // unsupported media type
     ITL_HTTP_STATUS_SERVER_ERROR = 500       ' // internal server error
     ITL_HTTP_STATUS_NOT_SUPPORTED = 501      ' // required not supported
     ITL_HTTP_STATUS_BAD_GATEWAY = 502        ' // error response received from gateway
     ITL_HTTP_STATUS_SERVICE_UNAVAIL = 503    ' // temporarily overloaded
     ITL_HTTP_STATUS_GATEWAY_TIMEOUT = 504    ' // timed out waiting for gateway
     ITL_HTTP_STATUS_VERSION_NOT_SUP = 505    ' // HTTP version not supported
     ITL_HTTP_STATUS_FIRST = ITL_HTTP_STATUS_CONTINUE
     ITL_HTTP_STATUS_LAST = ITL_HTTP_STATUS_VERSION_NOT_SUP
End Enum

Public Enum itlICUFlags
    ITL_ICU_ESCAPE = &H80000000      ' // (un)escape URL characters
    ITL_ICU_USERNAME = &H40000000   ' // use internal username & password
    ITL_ICU_NO_ENCODE = &H20000000   ' // Don't convert unsafe characters to escape sequence
    ITL_ICU_DECODE = &H10000000      ' // Convert %XX escape sequences to characters
    ITL_ICU_NO_META = &H8000000      ' // Don't convert .. etc. meta path sequences
    ITL_ICU_ENCODE_SPACES_ONLY = &H4000000  ' // Encode spaces only
    ITL_ICU_BROWSER_MODE = &H2000000 ' // Special encode/decode rules for browser
End Enum

Public Enum itlInternetOpenFlags
    ITL_INTERNET_OPEN_TYPE_PRECONFIG = 0  ' // use registry configuration
    ITL_INTERNET_OPEN_TYPE_DIRECT = 1   ' // direct to net
    ITL_INTERNET_OPEN_TYPE_PROXY = 3    '  // via named proxy
    ITL_INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY = 4   ' // prevent using java/script/INS
End Enum

Public Enum itlTransferFlags
    ITL_INTERNET_FLAG_TRANSFER_ASCII = FTP_TRANSFER_TYPE_ASCII
    ITL_INTERNET_FLAG_TRANSFER_BINARY = FTP_TRANSFER_TYPE_BINARY
End Enum

Public Enum itlHttpRequestType
    ITL_HTTP_REQUEST_TYPE_GET = 1
    ITL_HTTP_REQUEST_TYPE_POST = 2
    ITL_HTTP_REQUEST_TYPE_PUT = 3
End Enum

Private Const ERR_BASE = vbObjectError + 9876
Private Const INTERNET_ERROR_BASE = 12000

Public Enum itlErrors
    ITL_ERROR_BAD_URL = ERR_BASE + 1
    ITL_ERROR_REQUEST_FAILED = ERR_BASE + 2
    ITL_ERROR_UNKNOWN = ERR_BASE + 3
    ITL_ERROR_CONNECTION_FAIL = ERR_BASE + 4
    ITL_ERROR_CANNOT_START_TRANSFER = ERR_BASE + 5
    ITL_ERROR_FILE_NOT_FOUND = ERR_BASE + 6
    ITL_ERROR_USER_CANCEL = ERR_BASE + 7
    ITL_ERROR_FILE_ALREADY_EXISTS = ERR_BASE + 8
    ITL_ERROR_BAD_PATHNAME = 161
    ITL_ERROR_INVALID_PARAMETER = &H87
    ITL_ERROR_INTERNET_INVALID_URL = (INTERNET_ERROR_BASE + 5)
    ITL_ERROR_INSUFFICIENT_BUFFER = 122
    ITL_ERROR_NO_MORE_FILES = 18
    ITL_ERROR_INTERNET_OUT_OF_HANDLES = (INTERNET_ERROR_BASE + 1)
    ITL_ERROR_INTERNET_TIMEOUT = (INTERNET_ERROR_BASE + 2)
    ITL_ERROR_INTERNET_EXTENDED_ERROR = (INTERNET_ERROR_BASE + 3)
    ITL_ERROR_INTERNET_INTERNAL_ERROR = (INTERNET_ERROR_BASE + 4)
    ITL_ERROR_INTERNET_UNRECOGNIZED_SCHEME = (INTERNET_ERROR_BASE + 6)
    ITL_ERROR_INTERNET_NAME_NOT_RESOLVED = (INTERNET_ERROR_BASE + 7)
    ITL_ERROR_INTERNET_PROTOCOL_NOT_FOUND = (INTERNET_ERROR_BASE + 8)
    ITL_ERROR_INTERNET_INVALID_OPTION = (INTERNET_ERROR_BASE + 9)
    ITL_ERROR_INTERNET_BAD_OPTION_LENGTH = (INTERNET_ERROR_BASE + 10)
    ITL_ERROR_INTERNET_OPTION_NOT_SETTABLE = (INTERNET_ERROR_BASE + 11)
    ITL_ERROR_INTERNET_SHUTDOWN = (INTERNET_ERROR_BASE + 12)
    ITL_ERROR_INTERNET_INCORRECT_USER_NAME = (INTERNET_ERROR_BASE + 13)
    ITL_ERROR_INTERNET_INCORRECT_PASSWORD = (INTERNET_ERROR_BASE + 14)
    ITL_ERROR_INTERNET_LOGIN_FAILURE = (INTERNET_ERROR_BASE + 15)
    ITL_ERROR_INTERNET_INVALID_OPERATION = (INTERNET_ERROR_BASE + 16)
    ITL_ERROR_INTERNET_OPERATION_CANCELLED = (INTERNET_ERROR_BASE + 17)
    ITL_ERROR_INTERNET_INCORRECT_HANDLE_TYPE = (INTERNET_ERROR_BASE + 18)
    ITL_ERROR_INTERNET_INCORRECT_HANDLE_STATE = (INTERNET_ERROR_BASE + 19)
    ITL_ERROR_INTERNET_NOT_PROXY_REQUEST = (INTERNET_ERROR_BASE + 20)
    ITL_ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND = (INTERNET_ERROR_BASE + 21)
    ITL_ERROR_INTERNET_BAD_REGISTRY_PARAMETER = (INTERNET_ERROR_BASE + 22)
    ITL_ERROR_INTERNET_NO_DIRECT_ACCESS = (INTERNET_ERROR_BASE + 23)
    ITL_ERROR_INTERNET_NO_CONTEXT = (INTERNET_ERROR_BASE + 24)
    ITL_ERROR_INTERNET_NO_CALLBACK = (INTERNET_ERROR_BASE + 25)
    ITL_ERROR_INTERNET_REQUEST_PENDING = (INTERNET_ERROR_BASE + 26)
    ITL_ERROR_INTERNET_INCORRECT_FORMAT = (INTERNET_ERROR_BASE + 27)
    ITL_ERROR_INTERNET_ITEM_NOT_FOUND = (INTERNET_ERROR_BASE + 28)
    ITL_ERROR_INTERNET_CANNOT_CONNECT = (INTERNET_ERROR_BASE + 29)
    ITL_ERROR_INTERNET_CONNECTION_ABORTED = (INTERNET_ERROR_BASE + 30)
    ITL_ERROR_INTERNET_CONNECTION_RESET = (INTERNET_ERROR_BASE + 31)
    ITL_ERROR_INTERNET_FORCE_RETRY = (INTERNET_ERROR_BASE + 32)
    ITL_ERROR_INTERNET_INVALID_PROXY_REQUEST = (INTERNET_ERROR_BASE + 33)
    ITL_ERROR_INTERNET_NEED_UI = (INTERNET_ERROR_BASE + 34)
    ITL_ERROR_INTERNET_HANDLE_EXISTS = (INTERNET_ERROR_BASE + 36)
    ITL_ERROR_INTERNET_SEC_CERT_DATE_INVALID = (INTERNET_ERROR_BASE + 37)
    ITL_ERROR_INTERNET_SEC_CERT_CN_INVALID = (INTERNET_ERROR_BASE + 38)
    ITL_ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR = (INTERNET_ERROR_BASE + 39)
    ITL_ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR = (INTERNET_ERROR_BASE + 40)
    ITL_ERROR_INTERNET_MIXED_SECURITY = (INTERNET_ERROR_BASE + 41)
    ITL_ERROR_INTERNET_CHG_POST_IS_NON_SECURE = (INTERNET_ERROR_BASE + 42)
    ITL_ERROR_INTERNET_POST_IS_NON_SECURE = (INTERNET_ERROR_BASE + 43)
    ITL_ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED = (INTERNET_ERROR_BASE + 44)
    ITL_ERROR_INTERNET_INVALID_CA = (INTERNET_ERROR_BASE + 45)
    ITL_ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP = (INTERNET_ERROR_BASE + 46)
    ITL_ERROR_INTERNET_ASYNC_THREAD_FAILED = (INTERNET_ERROR_BASE + 47)
    iTL_ERROR_INTERNET_REDIRECT_SCHEME_CHANGE = (INTERNET_ERROR_BASE + 48)
    ITL_ERROR_INTERNET_DIALOG_PENDING = (INTERNET_ERROR_BASE + 49)
    ITL_ERROR_INTERNET_RETRY_DIALOG = (INTERNET_ERROR_BASE + 50)
    ITL_ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR = (INTERNET_ERROR_BASE + 52)
    ITL_ERROR_INTERNET_INSERT_CDROM = (INTERNET_ERROR_BASE + 53)
    ITL_ERROR_FTP_TRANSFER_IN_PROGRESS = (INTERNET_ERROR_BASE + 110)
    ITL_ERROR_FTP_DROPPED = (INTERNET_ERROR_BASE + 111)
    ITL_ERROR_FTP_NO_PASSIVE_MODE = (INTERNET_ERROR_BASE + 112)
    ITL_ERROR_HTTP_HEADER_NOT_FOUND = (INTERNET_ERROR_BASE + 150)
    ITL_ERROR_HTTP_DOWNLEVEL_SERVER = (INTERNET_ERROR_BASE + 151)
    ITL_ERROR_HTTP_INVALID_SERVER_RESPONSE = (INTERNET_ERROR_BASE + 152)
    ITL_ERROR_HTTP_INVALID_HEADER = (INTERNET_ERROR_BASE + 153)
    ITL_ERROR_HTTP_INVALID_QUERY_REQUEST = (INTERNET_ERROR_BASE + 154)
    ITL_ERROR_HTTP_HEADER_ALREADY_EXISTS = (INTERNET_ERROR_BASE + 155)
    ITL_ERROR_HTTP_REDIRECT_FAILED = (INTERNET_ERROR_BASE + 156)
    ITL_ERROR_HTTP_NOT_REDIRECTED = (INTERNET_ERROR_BASE + 160)
    ITL_ERROR_HTTP_COOKIE_NEEDS_CONFIRMATION = (INTERNET_ERROR_BASE + 161)
    ITL_ERROR_HTTP_COOKIE_DECLINED = (INTERNET_ERROR_BASE + 162)
    ITL_ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION = (INTERNET_ERROR_BASE + 168)
    ITL_ERROR_INTERNET_ITL_SECURITY_CHANNEL_ERROR = (INTERNET_ERROR_BASE + 157)
    ITL_ERROR_INTERNET_UNABLE_TO_CACHE_FILE = (INTERNET_ERROR_BASE + 158)
    ITL_ERROR_INTERNET_TCPIP_NOT_INSTALLED = (INTERNET_ERROR_BASE + 159)
    ITL_ERROR_INTERNET_DISCONNECTED = (INTERNET_ERROR_BASE + 163)
    ITL_ERROR_INTERNET_SERVER_UNREACHABLE = (INTERNET_ERROR_BASE + 164)
    ITL_ERROR_INTERNET_PROXY_SERVER_UNREACHABLE = (INTERNET_ERROR_BASE + 165)
    ITL_ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT = (INTERNET_ERROR_BASE + 166)
    ITL_ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT = (INTERNET_ERROR_BASE + 167)
    ITL_ERROR_INTERNET_SEC_INVALID_CERT = (INTERNET_ERROR_BASE + 169)
    ITL_ERROR_INTERNET_SEC_CERT_REVOKED = (INTERNET_ERROR_BASE + 170)
End Enum

Public Enum itlAddRequestFlags
    ITL_HTTP_ADDREQ_INDEX_MASK = &HFFFF
    ITL_HTTP_ADDREQ_FLAGS_MASK = &HFFFF0000
    ITL_HTTP_ADDREQ_FLAG_ADD_IF_NEW = &H10000000 ' // HTTP_ADDREQ_FLAG_ADD_IF_NEW - the header will only be added if it doesn't already exist
    ITL_HTTP_ADDREQ_FLAG_ADD = &H20000000        ' // HTTP_ADDREQ_FLAG_ADD - if HTTP_ADDREQ_FLAG_REPLACE is set but the header is not found then if this flag is set, the header is added anyway, so long as there is a valid header-value
    ITL_HTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA = &H40000000
    ITL_HTTP_ADDREQ_FLAG_COALESCE_WITH_SEMICOLON = &H1000000
    ITL_HTTP_ADDREQ_FLAG_COALESCE = ITL_HTTP_ADDREQ_FLAG_COALESCE_WITH_COMMA  ' // HTTP_ADDREQ_FLAG_COALESCE - coalesce headers with same name. e.g. "Accept: text/*" and "Accept: audio/*" with this flag results in a single header: "Accept: text/*, audio/*"
    ITL_HTTP_ADDREQ_FLAG_REPLACE = &H80000000  ' // HTTP_ADDREQ_FLAG_REPLACE - replaces the specified header. Only one header can e supplied in the buffer. If the header to be replaced is not the first  in a list of headers with the same name, then the relative index should be supplied in the low 8 bits of the dwModifiers parameter. If the header-value part is missing, then the header is removed
End Enum

Public Enum itlInternetOptions
    ITL_INTERNET_OPTION_CALLBACK = 1
    ITL_INTERNET_OPTION_CONNECT_TIMEOUT = 2
    ITL_INTERNET_OPTION_CONNECT_RETRIES = 3
    ITL_INTERNET_OPTION_CONNECT_BACKOFF = 4
    ITL_INTERNET_OPTION_SEND_TIMEOUT = 5
    ITL_INTERNET_OPTION_CONTROL_SEND_TIMEOUT = ITL_INTERNET_OPTION_SEND_TIMEOUT
    ITL_INTERNET_OPTION_RECEIVE_TIMEOUT = 6
    ITL_INTERNET_OPTION_CONTROL_RECEIVE_TIMEOUT = ITL_INTERNET_OPTION_RECEIVE_TIMEOUT
    ITL_INTERNET_OPTION_DATA_SEND_TIMEOUT = 7
    ITL_INTERNET_OPTION_DATA_RECEIVE_TIMEOUT = 8
    ITL_INTERNET_OPTION_HANDLE_TYPE = 9
    ITL_INTERNET_OPTION_LISTEN_TIMEOUT = 11
    ITL_INTERNET_OPTION_READ_BUFFER_SIZE = 12
    ITL_INTERNET_OPTION_WRITE_BUFFER_SIZE = 13
    ITL_INTERNET_OPTION_ASYNC_ID = 15
    ITL_INTERNET_OPTION_ASYNC_PRIORITY = 16
    ITL_INTERNET_OPTION_PARENT_HANDLE = 21
    ITL_INTERNET_OPTION_KEEP_CONNECTION = 22
    ITL_INTERNET_OPTION_REQUEST_FLAGS = 23
    ITL_INTERNET_OPTION_EXTENDED_ERROR = 24
    ITL_INTERNET_OPTION_OFFLINE_MODE = 26
    ITL_INTERNET_OPTION_CACHE_STREAM_HANDLE = 27
    ITL_INTERNET_OPTION_USERNAME = 28
    ITL_INTERNET_OPTION_PASSWORD = 29
    ITL_INTERNET_OPTION_ASYNC = 30
    ITL_INTERNET_OPTION_SECURITY_FLAGS = 31
    ITL_INTERNET_OPTION_SECURITY_CERTIFICATE_STRUCT = 32
    ITL_INTERNET_OPTION_DATAFILE_NAME = 33
    ITL_INTERNET_OPTION_URL = 34
    ITL_INTERNET_OPTION_SECURITY_CERTIFICATE = 35
    ITL_INTERNET_OPTION_SECURITY_KEY_BITNESS = 36
    ITL_INTERNET_OPTION_REFRESH = 37
    ITL_INTERNET_OPTION_PROXY = 38
    ITL_INTERNET_OPTION_SETTINGS_CHANGED = 39
    ITL_INTERNET_OPTION_VERSION = 40
    ITL_INTERNET_OPTION_USER_AGENT = 41
    ITL_INTERNET_OPTION_END_BROWSER_SESSION = 42
    ITL_INTERNET_OPTION_PROXY_USERNAME = 43
    ITL_INTERNET_OPTION_PROXY_PASSWORD = 44
    ITL_INTERNET_OPTION_CONTEXT_VALUE = 45
    ITL_INTERNET_OPTION_CONNECT_LIMIT = 46
    ITL_INTERNET_OPTION_SECURITY_SELECT_CLIENT_CERT = 47
    ITL_INTERNET_OPTION_POLICY = 48
    ITL_INTERNET_OPTION_DISCONNECTED_TIMEOUT = 49
    ITL_INTERNET_OPTION_CONNECTED_STATE = 50
    ITL_INTERNET_OPTION_IDLE_STATE = 51
    ITL_INTERNET_OPTION_OFFLINE_SEMANTICS = 52
    ITL_INTERNET_OPTION_SECONDARY_CACHE_KEY = 53
    ITL_INTERNET_OPTION_CALLBACK_FILTER = 54
    ITL_INTERNET_OPTION_CONNECT_TIME = 55
    ITL_INTERNET_OPTION_SEND_THROUGHPUT = 56
    ITL_INTERNET_OPTION_RECEIVE_THROUGHPUT = 57
    ITL_INTERNET_OPTION_REQUEST_PRIORITY = 58
    ITL_INTERNET_OPTION_HTTP_VERSION = 59
    ITL_INTERNET_OPTION_RESET_URLCACHE_SESSION = 60
    ITL_INTERNET_OPTION_ERROR_MASK = 62
    ITL_INTERNET_FIRST_OPTION = ITL_INTERNET_OPTION_CALLBACK
    ITL_INTERNET_LAST_OPTION = ITL_INTERNET_OPTION_ERROR_MASK
End Enum

Public Enum itlInternetSecurityOptions
    ITL_SECURITY_FLAG_IGNORE_REVOCATION = &H80
    ITL_SECURITY_FLAG_IGNORE_UNKNOWN_CA = &H100
    ITL_SECURITY_FLAG_IGNORE_WRONG_USAGE = &H200
    ITL_SECURITY_FLAG_IGNORE_CERT_CN_INVALID = ITL_INTERNET_FLAG_IGNORE_CERT_CN_INVALID
    ITL_SECURITY_FLAG_IGNORE_CERT_DATE_INVALID = ITL_INTERNET_FLAG_IGNORE_CERT_DATE_INVALID
    ITL_SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTPS = ITL_INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS
    ITL_SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTP = ITL_INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP
   
End Enum
 'ITL_SECURITY_SET_MASK = (ITL_SECURITY_FLAG_IGNORE_REVOCATION Or _
                                 ITL_SECURITY_FLAG_IGNORE_UNKNOWN_CA Or _
                                 ITL_SECURITY_FLAG_IGNORE_CERT_CN_INVALID Or _
                                 ITL_SECURITY_FLAG_IGNORE_CERT_DATE_INVALID Or _
                                 ITL_SECURITY_FLAG_IGNORE_WRONG_USAGE)
Public Enum itlQueryInfoLevels
    ITL_HTTP_QUERY_MIME_VERSION = 0
    ITL_HTTP_QUERY_CONTENT_TYPE = 1
    ITL_HTTP_QUERY_CONTENT_TRANSFER_ENCODING = 2
    ITL_HTTP_QUERY_CONTENT_ID = 3
    ITL_HTTP_QUERY_CONTENT_DESCRIPTION = 4
    ITL_HTTP_QUERY_CONTENT_LENGTH = 5
    ITL_HTTP_QUERY_CONTENT_LANGUAGE = 6
    ITL_HTTP_QUERY_ALLOW = 7
    ITL_HTTP_QUERY_PUBLIC = 8
    ITL_HTTP_QUERY_DATE = 9
    ITL_HTTP_QUERY_EXPIRES = 10
    ITL_HTTP_QUERY_LAST_MODIFIED = 11
    ITL_HTTP_QUERY_MESSAGE_ID = 12
    ITL_HTTP_QUERY_URI = 13
    ITL_HTTP_QUERY_DERIVED_FROM = 14
    ITL_HTTP_QUERY_COST = 15
    ITL_HTTP_QUERY_LINK = 16
    ITL_HTTP_QUERY_PRAGMA = 17
    ITL_HTTP_QUERY_VERSION = 18                      ' // special: part of status line
    ITL_HTTP_QUERY_STATUS_CODE = 19                  ' // special: part of status line
    ITL_HTTP_QUERY_STATUS_TEXT = 20                  ' // special: part of status line
    ITL_HTTP_QUERY_RAW_HEADERS = 21                  ' // special: all headers as ASCIIZ
    ITL_HTTP_QUERY_RAW_HEADERS_CRLF = 22            '  // special: all headers
    ITL_HTTP_QUERY_CONNECTION = 23
    ITL_HTTP_QUERY_ACCEPT = 24
    ITL_HTTP_QUERY_ACCEPT_CHARSET = 25
    ITL_HTTP_QUERY_ACCEPT_ENCODING = 26
    ITL_HTTP_QUERY_ACCEPT_LANGUAGE = 27
    ITL_HTTP_QUERY_AUTHORIZATION = 28
    ITL_HTTP_QUERY_CONTENT_ENCODING = 29
    ITL_HTTP_QUERY_FORWARDED = 30
    ITL_HTTP_QUERY_FROM = 31
    ITL_HTTP_QUERY_IF_MODIFIED_SINCE = 32
    ITL_HTTP_QUERY_LOCATION = 33
    ITL_HTTP_QUERY_ORIG_URI = 34
    ITL_HTTP_QUERY_REFERER = 35
    ITL_HTTP_QUERY_RETRY_AFTER = 36
    ITL_HTTP_QUERY_SERVER = 37
    ITL_HTTP_QUERY_TITLE = 38
    ITL_HTTP_QUERY_USER_AGENT = 39
    ITL_HTTP_QUERY_WWW_AUTHENTICATE = 40
    ITL_HTTP_QUERY_PROXY_AUTHENTICATE = 41
    ITL_HTTP_QUERY_ACCEPT_RANGES = 42
    ITL_HTTP_QUERY_SET_COOKIE = 43
    ITL_HTTP_QUERY_COOKIE = 44
    ITL_HTTP_QUERY_REQUEST_METHOD = 45               ' // special: GET/POST etc.
    ITL_HTTP_QUERY_REFRESH = 46
    ITL_HTTP_QUERY_CONTENT_DISPOSITION = 47
    ITL_HTTP_QUERY_AGE = 48
    ITL_HTTP_QUERY_CACHE_CONTROL = 49
    ITL_HTTP_QUERY_CONTENT_BASE = 50
    ITL_HTTP_QUERY_CONTENT_LOCATION = 51
    ITL_HTTP_QUERY_CONTENT_MD5 = 52
    ITL_HTTP_QUERY_CONTENT_RANGE = 53
    ITL_HTTP_QUERY_ETAG = 54
    ITL_HTTP_QUERY_HOST = 55
    ITL_HTTP_QUERY_IF_MATCH = 56
    ITL_HTTP_QUERY_IF_NONE_MATCH = 57
    ITL_HTTP_QUERY_IF_RANGE = 58
    ITL_HTTP_QUERY_IF_UNMODIFIED_SINCE = 59
    ITL_HTTP_QUERY_MAX_FORWARDS = 60
    ITL_HTTP_QUERY_PROXY_AUTHORIZATION = 61
    ITL_HTTP_QUERY_RANGE = 62
    ITL_HTTP_QUERY_TRANSFER_ENCODING = 63
    ITL_HTTP_QUERY_UPGRADE = 64
    ITL_HTTP_QUERY_VARY = 65
    ITL_HTTP_QUERY_VIA = 66
    ITL_HTTP_QUERY_WARNING = 67
    ITL_HTTP_QUERY_CUSTOM = 65535
End Enum

Public Enum itlHSRUploadFlags
    HSR_ASYNC = WININET_API_FLAG_ASYNC             '  // force async
    HSR_SYNC = WININET_API_FLAG_SYNC                 ' // force sync
End Enum

Public Enum itlFileAttributes
    ITL_FILE_ATTRIBUTE_READONLY = &H1
    ITL_FILE_ATTRIBUTE_HIDDEN = &H2
    ITL_FILE_ATTRIBUTE_SYSTEM = &H4
    ITL_FILE_ATTRIBUTE_DIRECTORY = &H10
    ITL_FILE_ATTRIBUTE_ARCHIVE = &H20
    ITL_FILE_ATTRIBUTE_NORMAL = &H80
    ITL_FILE_ATTRIBUTE_TEMPORARY = &H100
    ITL_FILE_ATTRIBUTE_COMPRESSED = &H800
End Enum

Private m_hInetSession As Long
Private m_hInetURL As Long
Private m_hConnect As Long
Private m_hReq As Long
Private m_lngSize As Long
Private m_tURLInfo As ITL_URL_COMPONENTS
Private m_blnIsPostMethod As Boolean
Private m_blnIsSecuredRequest As Boolean

Private m_sngFactor As Single
Private m_intVerbType As Integer
Private m_strExecContext As String
Private m_blnIsErr As Boolean
Private m_blnHeaderSent As Boolean
Private Const CLS_NAME = "HTTP -- "

Private Const ERR_GENERIC = vbObjectError + 5555

Public RaiseInternetAPIErrors As Boolean

Private m_strImpersonateBrowser As String

Public Property Let ImpersonateBrowser(ByVal UserAgentString As String)
Attribute ImpersonateBrowser.VB_Description = "Allows you to customize the UserAgent string. For Internet Explorer 5 running under Windows 2000, an example of the useragent value could be Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)"
Attribute ImpersonateBrowser.VB_MemberFlags = "440"
    m_strImpersonateBrowser = UserAgentString
End Property

Public Function FileDialog( _
                                ByVal InitialFileName As String, _
                                ByVal DialogTitle As String, _
                                ByVal Filter As String, _
                                ByVal DefaultExtension As String, _
                                ByVal StartInDirectory As String, _
                                ByVal OpenMode As Boolean, _
                                Optional ByVal hWnd As Long) _
                                As String
Attribute FileDialog.VB_Description = "Displays the standard Windows FileOpen dialog box"
'
'   Displays the standard Windows FileOpen dialog box
'
On Error GoTo ErrHandler
        
    FileDialog = fGetFileName(InitialFileName, hWnd, DialogTitle, Filter, DefaultExtension, StartInDirectory, OpenMode)
    
    Exit Function
ErrHandler:
   With Err
       .Raise .Number, .source, .Description, .HelpFile, .HelpContext
   End With
End Function

Public Function Upload( _
                                Optional ByVal FileName As String, _
                                Optional ByVal ReplaceFileOnServerIfExists As Boolean = False, _
                                Optional ByVal DialogTitle As String, _
                                Optional ByVal hWnd As Long, _
                                Optional ByVal Filter As String = "All Files|*.*", _
                                Optional ByVal StartInDirectory As String) _
                                As String
Attribute Upload.VB_Description = "Uploads the specified local file to the server using either the POST or PUT method"
'
' Uploads the specified local file to the server using either the POST or PUT method
'
' Arguments:
'       FileName                                      [ Optional ]               Default Value = vbNullString
'               The local file to upload to the server
'               If left empty (vbNullString), by default, the class will
'               present the user with the standard Windows FileOpen
'               dialog so that they may select the file
'
'       ReplaceFileOnServerIfExists             [ Optional ]               Default Value = False
'               If the file specified in the FileName argument already exists on the server
'               and the ReplaceFileOnServerIfExists flag is true, then the class
'               will delete and recreate the file.  If the flag is false (default),
'               the class will raise an error (ITL_ERROR_FILE_ALREADY_EXISTS)
'
'       DialogTitle                                     [ Optional ]                Default Value = vbNullString
'               The text that will be displayed as the caption for the Windows FileOpen
'               dialog. If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       hWnd                                            [ Optional ]               Default Value = 0
'               Handle to the window that will own the FileOpen dialog.
'               If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       Filter                                              [ Optional ]               Default Value = "All Files|*.*"
'               The file selection filter that the FileOpen dialog will use.
'               If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       StartInDirectory                               [ Optional ]             Default Value = vbNullString
'               The directory that will be initially pre-selected in the FileDialog
'
'
On Error GoTo ErrHandler
Dim lngPostSize As Long
Dim tIB As INTERNET_BUFFERS
Dim lngFrags As Long, i As Long, j As Integer
Dim pBuffer() As Byte, lngFlags As Long
Dim lngRet As Long, lngLeftOver As Long
Dim strOut As String, lngCode As Long, lngLen As Long
Dim hFile As Long, lngBytesRead As Long, lngBytesWritten As Long

    m_strExecContext = fGetExecContext("Upload")

    ' If no filename was specified, call the FileOpen dialog
    If (Len(FileName) = 0) Then
        FileName = fGetFileName(vbNullString, DialogTitle, hWnd, Filter, vbNullString, StartInDirectory, True)
    End If
    
    ' If the filename is still not present, the user must've clicked "Cancel".
    ' Exit out of the proc
    If (Len(FileName) = 0) Then
        Err.Raise ERR_GENERIC
    End If
    
    ' Get a handle to the local file
    hFile = FreeFile
    Open FileName For Binary Access Read Shared As hFile
    ' Calculate the size of the file
    lngPostSize = LOF(hFile)
    ReDim pBuffer(MAX_CHUNK - 1)
    ' Calculate how many times the download loop has to be run
    lngFrags = lngPostSize \ MAX_CHUNK
    lngLeftOver = lngPostSize Mod MAX_CHUNK
    
    With tIB
        .dwStructSize = Len(tIB)
        .dwBufferTotal = lngPostSize
    End With
    
    ' Initiate the Upload request
    m_blnIsErr = fAssertInetErr( _
            (HttpSendRequestEx(m_hReq, tIB, ByVal 0&, HSR_INITIATE, 0) = 0), _
            m_strExecContext, RaiseInternetAPIErrors)
    
    ' Write the data to the server
    For i = 1 To lngFrags
        Call sUploadProc(pBuffer, hFile, MAX_CHUNK, lngBytesWritten)
        
        ' Notify the clients of the progress
        RaiseEvent FileProgress(Format$((i * MAX_CHUNK / lngPostSize) * 100, DECIMAL_FORMAT))
    Next
    If (lngLeftOver) Then
        Call sUploadProc(pBuffer, hFile, lngLeftOver, lngBytesWritten)
        
        ' Since this "If-Then" block will run only once per
        ' file, the fileprogress can be safely assumed to be 100%
        ' at this point (provided there were no errors)
        RaiseEvent FileProgress(100)
    End If
    ' Close the open handle
    Close #hFile
    
    ' Terminate the HTTP Request session
    Call sCloseRequestHandleProc
    
    ' If the file was uploaded using either the POST or the PUT method, then
    ' the server could respond back with some headers. Read
    ' any responses being sent back to the client and return the text
    If (m_blnIsPostMethod) Then
        ReDim pBuffer(0 To MAX_CHUNK_SMALL - 1)
        Do
            lngBytesRead = 0
            ' Read the response
            m_blnIsErr = fAssertInetErr( _
                (InternetReadFile(m_hReq, pBuffer(0), MAX_CHUNK_SMALL, lngBytesRead) = 0), _
                m_strExecContext, RaiseInternetAPIErrors)
            
            If (lngBytesRead) Then
                strOut = strOut & fTrimNull(StrConv(pBuffer, vbUnicode))
            End If
        Loop While (lngBytesRead > 0)
        Upload = strOut
    End If
    
    Exit Function
ErrHandler:
    Close #hFile
   With Err
        If (.Number = ITL_ERROR_INTERNET_FORCE_RETRY) Then
            RaiseEvent StatusChanged(LoadResString(ITL_FORCE_RETRY))
        ElseIf (.Number <> ERR_GENERIC) Then
            .Raise .Number, .source, .Description, .HelpFile, .HelpContext
        End If
   End With
End Function

Private Function fInitSSL() As Boolean
Dim lngFlags As Long, lngRet As Long
Dim lngCode As Long, lngLen As Long
Dim strTmp As String

        lngFlags = ITL_SECURITY_FLAG_IGNORE_UNKNOWN_CA Or _
                           ITL_SECURITY_FLAG_IGNORE_REVOCATION Or _
                           ITL_SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTP Or _
                           ITL_SECURITY_FLAG_IGNORE_REDIRECT_TO_HTTPS Or _
                           ITL_SECURITY_FLAG_IGNORE_CERT_DATE_INVALID Or _
                           ITL_SECURITY_FLAG_IGNORE_CERT_CN_INVALID

        m_blnIsErr = fAssertInetErr( _
                            (InternetSetOption(m_hReq, ITL_INTERNET_OPTION_SECURITY_FLAGS, lngFlags, 4) = 0), _
                            m_strExecContext, _
                            RaiseInternetAPIErrors)
    
        m_blnIsErr = fAssertInetErr( _
                            (CLng(Me.SendRequest(vbNullString)) = 0), _
                            m_strExecContext, _
                            RaiseInternetAPIErrors)
        
        lngLen = 10
        strTmp = String$(lngLen - 1, vbNullChar)
        lngRet = HttpQueryInfo(m_hReq, ITL_HTTP_QUERY_STATUS_CODE Or ITL_HTTP_QUERY_FLAG_NUMBER, ByVal strTmp, lngLen, 0)
        If (lngRet = 0 And Err.LastDllError = ITL_ERROR_INSUFFICIENT_BUFFER) Then
            strTmp = String$(lngLen - 1, vbNullChar)
            lngRet = HttpQueryInfo(m_hReq, ITL_HTTP_QUERY_STATUS_CODE Or ITL_HTTP_QUERY_FLAG_NUMBER, ByVal strTmp, lngLen, 0)
        End If
        
        If (lngLen) Then
            m_blnIsErr = fAssertInetErr( _
                            (HttpQueryInfo(m_hReq, ITL_HTTP_QUERY_STATUS_CODE Or ITL_HTTP_QUERY_FLAG_NUMBER, ByVal strTmp, lngLen, 0) = 0), _
                            m_strExecContext, _
                            RaiseInternetAPIErrors)
            
            lngCode = CLng(Left$(strTmp, lngLen))
            If (lngCode = ITL_HTTP_STATUS_DENIED Or lngCode = ITL_HTTP_STATUS_PROXY_AUTH_REQ) Then
                Do
                    Call InternetReadFile(m_hReq, ByVal 0, 50, lngLen)
                Loop While (lngLen <> 0)
            
                fInitSSL = InternetErrorDlg( _
                                        GetDesktopWindow(), m_hReq, _
                                        ITL_ERROR_INTERNET_INCORRECT_PASSWORD, _
                                        FLAGS_ERROR_UI_FILTER_FOR_ERRORS Or _
                                        FLAGS_ERROR_UI_FLAGS_GENERATE_DATA Or _
                                        FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS, _
                                        ByVal 0)
            
            End If
        End If
End Function

Private Static Sub sUploadProc(pBuffer() As Byte, hFile As Long, lngLeftOver As Long, lngBytesWritten As Long)
Static j As Integer, i As Integer
Static lngRet As Long

    i = 0
    j = 0
    lngRet = 0

    Call ZeroMem(pBuffer(0), MAX_CHUNK)
    ' Read MAX_CHUNKS from the local file
    Get hFile, , pBuffer
    ' Send the bytes to the server and make sure that the API functions did not fail
    lngRet = InternetWriteFile(m_hReq, pBuffer(0), lngLeftOver, lngBytesWritten)
    If (Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY And lngRet = 0) Then
        j = 0
        Do While (lngRet = 0 And Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY)
            lngRet = InternetWriteFile(m_hReq, pBuffer(0), lngLeftOver, lngBytesWritten)
            If (j > 4) Then
                If (Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY And lngRet = 0) Then
                    ' Terminate the HTTP Request session
                   Call sCloseRequestHandleProc
                    
                    'm_blnIsErr = fAssertInetErr( _
                                            (HttpEndRequest(m_hReq, ByVal 0, HSR_INITIATE, 0) = 0), _
                                            m_strExecContext, RaiseInternetAPIErrors)
                    m_blnIsErr = fAssertInetErr(lngRet = 0, _
                                                    m_strExecContext, RaiseInternetAPIErrors)
                    Exit Do
                End If
            End If
            j = j + 1
        Loop
    Else
        m_blnIsErr = fAssertInetErr(lngRet = 0, _
                    m_strExecContext, RaiseInternetAPIErrors)
    End If
End Sub

Private Static Sub sCloseRequestHandleProc()
Static j As Integer, i As Integer
Static lngRet As Long

    i = 0
    j = 0
    lngRet = 0
    
    lngRet = HttpEndRequest(m_hReq, ByVal 0, HSR_INITIATE, 0)
    If (Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY And lngRet = 0) Then
        If (j > 4) Then
            m_blnIsErr = fAssertInetErr(lngRet = 0, _
                                                    m_strExecContext, RaiseInternetAPIErrors)
        Else
            Do While (lngRet = 0 And Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY And j <= 4)
                lngRet = HttpEndRequest(m_hReq, ByVal 0, HSR_INITIATE, 0)
            Loop
            If (lngRet = 0 And Err.LastDllError = itlErrors.ITL_ERROR_INTERNET_FORCE_RETRY And j <= 4) Then
                m_blnIsErr = fAssertInetErr(lngRet = 0, _
                                                    m_strExecContext, RaiseInternetAPIErrors)
            End If
        End If
    End If
End Sub

Public Function Download(Optional ByVal FileName As String, _
                                Optional ByVal InitialFileName As String, _
                                Optional ByVal OverWriteIfPresent As Boolean, _
                                Optional ByVal DialogTitle As String, _
                                Optional ByVal hWnd As Long, _
                                Optional ByVal Filter As String = "All Files|*.*", _
                                Optional ByVal StartInDirectory As String) _
                                As String
Attribute Download.VB_Description = "Saves the referenced WWW resource as a persisted file on the hard disk"
'
' Saves the referenced WWW resource as a persisted file on the hard disk.
'
' Arguments:
'       FileName                        [ Optional ]               Default Value = vbNullString
'               The name to use when creating the local file
'               If left empty (vbNullString), by default, the class will
'               present the user with the standard Windows FileSave
'               dialog so that they may specify a filename
'
'       OverWriteIfPresent          [ Optional ]               Default Value = False
'               If the file specified in the FileName argument already exists
'               and the OverWriteIfPresent flag is true, then the class
'               will delete and recreate the file.  If the flag is false (default),
'               the class will raise an error (ITL_ERROR_FILE_ALREADY_EXISTS)
'
'       DialogTitle                      [ Optional ]                Default Value = vbNullString
'               The text that will be displayed as the caption for the Windows FileOpen
'               dialog. If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       hWnd                            [ Optional ]               Default Value = 0
'               Handle to the window that will own the FileOpen dialog.
'               If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       Filter                              [ Optional ]               Default Value = "All Files|*.*"
'               The file selection filter that the FileOpen dialog will use.
'               If you are passing a FileName, then there's no need to
'               pass a value for DialogTitle.
'
'       StartInDirectory               [ Optional ]             Default Value = vbNullString
'               The directory that will be initially pre-selected in the FileDialog
'
'
On Error GoTo ErrHandler
Dim clsDlg As CDialog
Dim strFileName As String
Dim hFile As Long
Dim abytData() As Byte
Dim lngTotalByesRead As Long
Dim lngTotalBytesWritten As Long
Dim lngBytesWritten As Long
Dim lngBytesRead As Long, lngRet As Long

    m_strExecContext = fGetExecContext("Download")

    ' Get the size of the requrested resource
    m_lngSize = Me.QueryInfo(ITL_HTTP_QUERY_CONTENT_LENGTH, 0)
    ' A lot of times, the server will not support the ITL_HTTP_QUERY_CONTENT_LENGTH header
    ' in that case, set the size to a 100 (since it's only being used to track progress)
    If (m_lngSize = 0) Then m_lngSize = 100

    ' If no filename was specified, call the FileOpen dialog
    If (Len(FileName) = 0) Then
        FileName = fGetFileName(InitialFileName, hWnd, DialogTitle, Filter, vbNullString, StartInDirectory, False)
    End If
    
    If (Len(FileName) = 0) Then
        ' If the filename is not present, then exit out of the method
        Err.Raise ERR_GENERIC
    Else
        ' If a filename was supplied, and the file already exists
        If (Len(Dir$(FileName, vbNormal))) Then
            ' if the OverWriteIfPresent flag was true, then
            ' delete the file
            If (OverWriteIfPresent) Then
                ' Do Nothing
            Else
                ' The file exists, but the overwrite flag is false. Raise an error
                With Err
                    .Raise ITL_ERROR_FILE_ALREADY_EXISTS, m_strExecContext, _
                        "The file specified, '" & FileName & "'" & vbCrLf & _
                            "already exists. Either delete the file before calling the 'Download' method, " & _
                            "or set the OverWriteIfPresent argument in the method call to True."
                End With
            End If
        End If
    End If
    
    ' Get a handle to the local file
    hFile = CreateFile( _
                    FileName, GENERIC_READ Or GENERIC_WRITE, _
                    0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
  
    ' Make sure the handle is valid
    If hFile = INVALID_HANDLE_VALUE Then
        With Err
            .Raise .LastDllError, m_strExecContext, fAPIErr(.LastDllError)
        End With
    End If
    
    Do
        ReDim abytData(MAX_CHUNK - 1)
        ' Read MAX_CHUNKS from the requested resource
        lngRet = InternetReadFile( _
                        m_hReq, _
                        abytData(0), _
                        MAX_CHUNK, _
                        lngBytesRead)
        
        m_blnIsErr = fAssertInetErr((lngRet = 0), m_strExecContext, RaiseInternetAPIErrors)
        
        ' Write the chunks out to a local file
        m_blnIsErr = fAssertInetErr( _
            (WriteFile(hFile, abytData(0), lngBytesRead, lngBytesWritten, 0) = 0), _
            m_strExecContext, RaiseInternetAPIErrors)

        ' Keep track of total bytes written
        lngTotalBytesWritten = lngTotalBytesWritten + lngBytesWritten
        ' Notify the clients of the progress
        If (m_lngSize = 100) Then
            RaiseEvent FileProgress((lngTotalBytesWritten \ (lngTotalBytesWritten - 1)) * 100)
        Else
            RaiseEvent FileProgress(Format$((lngTotalBytesWritten / m_lngSize) * 100, DECIMAL_FORMAT))
        End If
    Loop Until lngRet <> 0 And lngBytesRead = 0
  
    ' Clear the cache and close open handles associated with the local file
    Call FlushFileBuffers(hFile)
    Call CloseHandle(hFile)
    
    Download = FileName
    Exit Function
ErrHandler:
    Call FlushFileBuffers(hFile)
    Call CloseHandle(hFile)
    With Err
        If (.Number <> ERR_GENERIC) Then
            .Raise .Number, .source, .Description, .HelpFile, .HelpContext
        End If
    End With
End Function

Public Property Get HTML() As String
Attribute HTML.VB_Description = "Returns the contents of a text file located on a remote server"
'
'  Returns the contents of a text file located on a remote server.
'
'
On Error GoTo ErrHandler
Dim lngRet As Long, i As Integer
Dim lngBytesRead As Long
Dim lngTotalByesRead As Long
Dim strTmp As String
Dim abytHTML() As Byte
Dim avarFileName As Variant
Dim blnNoProgress As Boolean

    m_strExecContext = fGetExecContext("HTML")
    
    ' If the handles are not valid, then raise an error
    If ((m_hInetSession = 0) Or (m_hConnect = 0) Or (m_hReq = 0 And m_hInetURL = 0)) Then
        Err.Raise ITL_ERROR_CANNOT_START_TRANSFER, _
            m_strExecContext, _
            "Internet functions are not in an initialized state." & _
            "Please use the Connect and then the OpenRequest methods first."
    End If
    
    If (m_blnIsSecuredRequest) Then
        lngRet = fInitSSL
        i = 0
        Do While (lngRet = ITL_ERROR_INTERNET_FORCE_RETRY)
            lngRet = fInitSSL
            If (i > 4) Then Exit Do
            i = i + 1
        Loop
        If (i > 4 And lngRet = ITL_ERROR_INTERNET_FORCE_RETRY) Then
            m_blnIsErr = fAssertInetErr(True, vbNullString, False)
        End If
    End If
    
    ' Initialize the request
    If (Not m_blnIsPostMethod) Then
        m_blnIsErr = fAssertInetErr((CBool(Me.SendRequest(vbNullString)) = False), m_strExecContext, RaiseInternetAPIErrors)
    End If
    
    ' Determine the file type
    strTmp = Me.QueryInfo(ITL_HTTP_QUERY_CONTENT_TYPE, vbNullString)
    
    ' If the file type is not text then call the Download method with the defaults
    If ((InStr(1, strTmp, HTTP_CONTENT_TYPE_TEXT_LEADER_CHARS, vbTextCompare) = 0) And (Len(strTmp))) Then
        avarFileName = Split(m_tURLInfo.lpszUrlPath, "/", , vbTextCompare)
        avarFileName = Me.Download(InitialFileName:=avarFileName(UBound(avarFileName)))
        Err.Raise ERR_GENERIC
    End If
    
    ' get the size of the content
    m_lngSize = Me.QueryInfo(ITL_HTTP_QUERY_CONTENT_LENGTH, -1)
    If (m_lngSize = -1) Then
        blnNoProgress = True
    End If

    ' If the RequestVerb was GET, then send an empty HttpSendRequest to the server.
    ' This seems to be a bug in WinInet as I haven't found this behavior to be
    ' documented anywhere in MSDN. If you know of what can cause this to happen,
    ' then please do send me an email (dev@mvps.org) with the information
    If (Not m_blnIsPostMethod) Then
        m_blnIsErr = fAssertInetErr((CBool(Me.SendRequest(vbNullString)) = False), _
                                            m_strExecContext, RaiseInternetAPIErrors)
    End If
    
    ' Download the requested resource in chunks
    strTmp = vbNullString
    Do
        ReDim abytHTML(MAX_CHUNK - 1)
        
        ' Read MAX_CHUNK from the WWW resource
        lngRet = InternetReadFile( _
                                m_hReq, _
                                abytHTML(0), _
                                MAX_CHUNK, _
                                lngBytesRead)
            
        m_blnIsErr = fAssertInetErr((lngRet = 0), m_strExecContext, RaiseInternetAPIErrors)
    
        ' if some bytes were successfully read
        If (lngBytesRead) Then
            ' then append the chunk to the main byte stream
            strTmp = strTmp & Mid$((StrConv(abytHTML, vbUnicode)), 1, lngBytesRead)
            
            lngTotalByesRead = lngTotalByesRead + lngBytesRead
            ' Inform the clients of the progress if the RequestVerb was not POST
            If (Not m_blnIsPostMethod) Then
                If (blnNoProgress) Then
                    RaiseEvent FileProgress((lngTotalByesRead \ (lngTotalByesRead - 1)) * 100)
                Else
                    RaiseEvent FileProgress((lngTotalByesRead / m_lngSize) * 100)
                End If
            End If
        End If
    Loop While (lngRet <> 0) And (lngBytesRead <> 0)
    
    ' Return the contents
    HTML = strTmp
    Erase abytHTML
    Exit Property
ErrHandler:
    Erase abytHTML
    With Err
        If (.Number = ERR_GENERIC) Then
            If (Len(avarFileName)) Then
                HTML = avarFileName
                With m_tURLInfo
                    RaiseEvent StatusChanged("Saved " & .lpszUrlPath & .lpszHostName & " to " & avarFileName & ".")
                End With
            End If
        Else
            .Raise .Number, .source, .Description, .HelpFile, .HelpContext
        End If
    End With
End Property

Public Function QueryInfo( _
                ByVal InfoLevel As itlQueryInfoLevels, _
                Optional IgnoreErrAndReturnValueIfNull As Variant) _
                As Variant
Attribute QueryInfo.VB_Description = "Retrieves header information associated with an HTTP request"
'
' Retrieves header information associated with an HTTP request. If a header
' does not exist, then the error ITL_ERROR_HTTP_HEADER_NOT_FOUND is raised
' by the class module.
'
' Arguments:
'   InfoLevel                       [ Required ]
'       Contains a combination of an attribute to retrieve and the flags that modify the request,
'       for which information is to be retrieved from the headers
'
On Error GoTo ErrHandler
Dim abytData() As Byte
Dim lngLen As Long, intCnt As Integer
Dim lngRet As Long
Dim blnDoQueryAgain As Boolean
Dim hHandle As Long
Dim strOut As Variant
Const MAX_TRIES = 5

    On Error GoTo ErrHandler
    
    m_strExecContext = fGetExecContext("QueryInfo")
    
    ' If the handles are not valid, then raise an error
    If ((m_hInetSession = 0) Or (m_hConnect = 0) Or (m_hReq = 0)) Then
        Err.Raise itlErrors.ITL_ERROR_CANNOT_START_TRANSFER, _
            m_strExecContext, _
            "Internet functions are not in an initialized state."
    End If
        
    Do
        If (m_blnHeaderSent) Then
           lngRet = True
        Else
            lngRet = Me.SendRequest(vbNullString)
            m_blnHeaderSent = True
        End If
        
        If (CBool(lngRet)) Then
            ReDim abytData(MAX_CHUNK - 1)
            lngLen = UBound(abytData)
            lngRet = HttpQueryInfo( _
                            m_hReq, _
                            InfoLevel, _
                            abytData(0), _
                            lngLen, _
                            0)
             If (lngRet = 0 And Err.LastDllError = ITL_ERROR_INSUFFICIENT_BUFFER) Then
                ReDim abytData(lngLen - 1)
                lngRet = HttpQueryInfo( _
                            hHandle, _
                            InfoLevel, _
                            abytData(0), _
                            lngLen, _
                            0)
            Else
                m_blnIsErr = fAssertInetErr((lngRet = 0), m_strExecContext, RaiseInternetAPIErrors)
            End If
            Exit Do
        End If
        intCnt = intCnt + 1
    Loop While (intCnt < MAX_TRIES)
    
    ' Trim and convert the Unicode buffer
    strOut = fTrimNull(StrConv(abytData, vbUnicode))
    QueryInfo = IIf((Len(strOut) = 0), IgnoreErrAndReturnValueIfNull, strOut)
    
    Exit Function
ErrHandler:
    With Err
        If (IsMissing(IgnoreErrAndReturnValueIfNull)) Then
            .Raise .Number, .source, .Description, .HelpFile, .HelpContext
        Else
            QueryInfo = IgnoreErrAndReturnValueIfNull
        End If
    End With
End Function

Public Function AddHeaders(ByVal Header As String, _
                                    ByVal RequestFlags As itlAddRequestFlags) _
                                    As Boolean
Attribute AddHeaders.VB_Description = "Adds one or more free-format headers to the HTTP request handle and is intended for use by sophisticated clients that need detailed control over the exact request sent to the HTTP server"
'
' Adds one or more free-format headers to the HTTP request handle and is intended
' for use by sophisticated clients that need detailed control over the exact request
' sent to the HTTP server.
'
' Arguments:
'   Header                               [ Required ]
'       The header string that is to be added to the Request header. If you are specifying
'       more than one headers, then they must be separated by vbCrLf.
'
'   RequestFlags                       [ Required ]
'       Determines the semantics of the method.

On Error GoTo ErrHandler
Dim lngRet As Long

    m_strExecContext = fGetExecContext("AddHeaders")

    ' If the handles are not valid, then raise an error
    If ((m_hInetSession = 0) Or (m_hConnect = 0) Or (m_hReq = 0)) Then
        Err.Raise itlErrors.ITL_ERROR_CANNOT_START_TRANSFER, _
            m_strExecContext, _
            "Internet functions are not in an initialized state. " & _
            "Please use the Connect and then the OpenRequest methods first."
    End If

    If (Len(Header)) Then
        ' Each header must be terminated by a vbCrLf
        Header = Header & vbCrLf
        ' Add the header
        lngRet = HttpAddRequestHeaders( _
                            m_hReq, _
                            Header, _
                            Len(Header), _
                            RequestFlags)
        ' Make sure that the API call did not fail
        m_blnIsErr = fAssertInetErr( _
                                (lngRet = 0), _
                                m_strExecContext, RaiseInternetAPIErrors)
    End If
    
    
    AddHeaders = True
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

Public Function SendRequest(Optional ByVal OptionalData As String) _
                                            As Boolean
Attribute SendRequest.VB_Description = "The method sends the appended headers to the server immediately if the SendImmediately argument is true (by default)"
'
' The method sends the appended headers to the
' server immediately if the SendImmediately argument is true (by default).
'
' Arguments:
'   OptionalData                       [ Optional ]                 Default Value = vbNullString
'       Contains any optional data to send immediately after the request headers.
'       This parameter is generally used for POST and PUT operations. The optional data
'       can be the resource or information being posted to the server
'
'   SendImmediately                 [ Optional ]                Default Value = True
'       Determines whether the method will call HttpSendRequest API function after
'       appending the headers by using the HttpAddRequestHeaders API function
'

On Error GoTo ErrHandler
Dim lngRet As Long, lngFlags As Long
Dim Cancel As Boolean

    m_strExecContext = fGetExecContext("SendRequest")

    ' If the handles are not valid, then raise an error
    If ((m_hInetSession = 0) Or (m_hConnect = 0) Or (m_hReq = 0)) Then
        Err.Raise itlErrors.ITL_ERROR_CANNOT_START_TRANSFER, _
            m_strExecContext, _
            "Internet functions are not in an initialized state. " & _
            "Please use the Connect and then the OpenRequest methods first."
    End If

    ' Send any optional data to the server
    lngRet = HttpSendRequest( _
                    m_hReq, _
                    vbNullString, _
                    0, _
                    ByVal OptionalData, _
                    Len(OptionalData))
        
    ' Make sure that the API call did not fail
    m_blnIsErr = fAssertInetErr( _
                    (lngRet = 0), _
                    m_strExecContext, RaiseInternetAPIErrors)
    
    m_blnHeaderSent = True
    
    lngRet = CLng(Me.QueryInfo(ITL_HTTP_QUERY_STATUS_CODE, 0))

    Select Case lngRet
        ' Authorize
        Case ITL_HTTP_STATUS_DENIED, ITL_HTTP_STATUS_PROXY_AUTH_REQ
            lngFlags = ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR Or _
                                    ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR Or _
                                    ERROR_INTERNET_INCORRECT_PASSWORD Or _
                                    ERROR_ERROR_INTERNET_INVALID_CA Or _
                                    ERROR_INTERNET_POST_IS_NON_SECURE Or _
                                    ERROR_INTERNET_SEC_CERT_DATE_INVALID Or _
                                    ERROR_INTERNET_SEC_CERT_CN_INVALID
            lngRet = InternetErrorDlg( _
                                GetDesktopWindow(), _
                                m_hReq, _
                                lngFlags, _
                                FLAGS_ERROR_UI_FILTER_FOR_ERRORS Or _
                                FLAGS_ERROR_UI_FLAGS_GENERATE_DATA Or _
                                FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS, _
                                ByVal 0)
            If (lngRet = ITL_ERROR_INTERNET_FORCE_RETRY) Then
                Call OpenRequest(m_intVerbType, 0)
            End If
        
        ' Redirect
        Case ITL_HTTP_STATUS_REDIRECT, ITL_HTTP_STATUS_MOVED, ITL_HTTP_STATUS_REDIRECT_METHOD
            lngRet = CStr(Me.QueryInfo(ITL_HTTP_QUERY_LOCATION))
            If (Len(lngRet)) Then
                With m_tURLInfo
                    If (Len(.lpszExtraInfo)) Then
                        RaiseEvent Redirect(.lpszScheme & "//" & .lpszHostName & "/" & .lpszExtraInfo, _
                                                                    .lpszUrlPath & .lpszExtraInfo, Cancel)
                    Else
                        RaiseEvent Redirect(.lpszScheme & "//" & .lpszHostName & "/" & .lpszExtraInfo, _
                                                                    .lpszUrlPath, Cancel)
                    End If
                    
                    If (Not Cancel) Then
                        'Call Me.Connect(URL:=(.lpszScheme & "//" & .lpszHostName & "/" & strTmp))
                        'Call Me.OpenRequest(RequestVerbType, Flags)
                    End If
                End With
            End If
    End Select

    SendRequest = True
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

Public Function OpenRequest( _
                            Optional ByVal RequestVerbType As itlHttpRequestType = ITL_HTTP_REQUEST_TYPE_GET, _
                            Optional ByVal Flags As itlConnectFlags = 0&) As String
Attribute OpenRequest.VB_Description = "Opens a request channel to the specified WWW resource after a connection had been established by using the Connect method"
'
' Opens a request channel to the specified WWW resource after a connection
' had been established by using the Connect method.
'
' Arguments
'   RequestVerbType                         [ Optional ]            Default Value = ITL_HTTP_REQUEST_TYPE_GET
'       Determines the action that will be performed on the request.  A brief description of the verbs is as follows:
'               ITL_HTTP_REQUEST_TYPE_GET   -   The requested resource will be downloaded (or fetched)
'               ITL_HTTP_REQUEST_TYPE_POST -   Bytes will be sent to the server on this handle using the
'                                                                    HTTP Post method. The resource has to be set up on the
'                                                                    server to receive the bytes and do something with the content
'               ITL_HTTP_REQUEST_TYPE_PUT   -   Bytes will be sent in the form of a file to the server on this handle.
'                                                                    The HTTP protocol will automatically create any folders, if needed,
'                                                                    based on the URL specified in the Connect method.
'                                                                    The folder on the server must have "Write" permissions enabled.
'                                                                    Under IIS, this can be set in the folder's properties in the MMC.
'   Flags                                           [ Optional ]            Default Value = 0
'       Acceptable values for the Flags arguments are:
'           INTERNET_FLAG_CACHE_IF_NET_FAIL, INTERNET_FLAG_HYPERLINK, INTERNET_FLAG_IGNORE_CERT_CN_INVALID
'           INTERNET_FLAG_IGNORE_CERT_DATE_INVALID, INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP,
'           INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS, INTERNET_FLAG_KEEP_CONNECTION, INTERNET_FLAG_NEED_FILE
'           INTERNET_FLAG_NO_AUTH, INTERNET_FLAG_NO_AUTO_REDIRECT, INTERNET_FLAG_NO_CACHE_WRITE
'           INTERNET_FLAG_NO_COOKIES, INTERNET_FLAG_NO_UI, INTERNET_FLAG_PRAGMA_NOCACHE, INTERNET_FLAG_RELOAD
'           INTERNET_FLAG_RESYNCHRONIZE, INTERNET_FLAG_SECURE,
'
On Error GoTo ErrHandler
Dim strVerb As String
Dim hReq As Long
Dim lngFlags As Long
Dim strTmp As String
Dim astrTypes(0) As String
Dim alngTypes(0) As String
Dim i As Integer

    m_strExecContext = fGetExecContext("OpenRequest")

    lngFlags = lngFlags Or Flags
    
    ' If the handles are not valid, then raise an error
    If ((m_hInetSession = 0) Or (m_hConnect = 0)) Then
        Err.Raise itlErrors.ITL_ERROR_CANNOT_START_TRANSFER, _
            m_strExecContext, _
            "Internet functions are not in an initialized state. Please use the Connect method before calling MakeRequest."
    End If
    
    ' Transform the specified verb into it's corressponding String value
    m_intVerbType = RequestVerbType
    Select Case RequestVerbType
        Case ITL_HTTP_REQUEST_TYPE_POST
            strVerb = HTTP_VERB_POST
            m_blnIsPostMethod = True
            lngFlags = itlConnectFlags.ITL_INTERNET_FLAG_RELOAD
        Case ITL_HTTP_REQUEST_TYPE_GET
            strVerb = HTTP_VERB_GET
            m_blnIsPostMethod = False
        Case ITL_HTTP_REQUEST_TYPE_PUT
            strVerb = HTTP_VERB_PUT
            m_blnIsPostMethod = False
            lngFlags = ITL_INTERNET_FLAG_NO_CACHE_WRITE Or _
                                    ITL_INTERNET_FLAG_KEEP_CONNECTION
    End Select
    
    If (m_blnIsSecuredRequest) Then lngFlags = lngFlags Or _
                                                                        ITL_INTERNET_FLAG_SECURE Or _
                                                                        ITL_INTERNET_FLAG_IGNORE_CERT_CN_INVALID Or _
                                                                        ITL_INTERNET_FLAG_IGNORE_CERT_DATE_INVALID
    
    With m_tURLInfo
        If (Len(.lpszExtraInfo)) Then
            strTmp = .lpszUrlPath & .lpszExtraInfo
        Else
            strTmp = .lpszUrlPath
        End If
        astrTypes(0) = ALL_FILES_FORMAT
        alngTypes(0) = StrPtr(astrTypes(0))
        
        If (RequestVerbType = ITL_HTTP_REQUEST_TYPE_POST) Then
            m_hReq = HttpOpenRequest( _
                                m_hConnect, _
                                strVerb, _
                                strTmp, _
                                HTTP_VERSION, _
                                vbNullString, _
                                0, _
                                lngFlags, _
                                0)
        Else
            m_hReq = HttpOpenRequest( _
                                m_hConnect, _
                                strVerb, _
                                strTmp, _
                                HTTP_VERSION, _
                                vbNullString, _
                                VarPtr(alngTypes(0)), _
                                lngFlags, _
                                0)
        End If
    End With
    
    m_blnIsErr = fAssertInetErr((m_hReq = 0), m_strExecContext, RaiseInternetAPIErrors)
           
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

Public Sub Connect( _
                    ByVal URL As String, _
                    Optional ByVal UserName As String, _
                    Optional ByVal Password As String, _
                    Optional ByVal UseHTTPS As Boolean)
Attribute Connect.VB_Description = "Connects to the specified URL"
'
' Connects to the specified URL. This method can be called without calling InternetStart
' first as it will check the handle (m_hInetSession) and if it's not valid, the method will internally
' call the InternetStart method with the default values for the arguments.
' If you need to change the default values with with InternetStart initializes the
' functions, then call InternetStart first before calling Connect.
'
' Arguments:
'   URL                         Required
'       Contains the link to the resource you wish to connect to. For example, http://www.microsoft.com
'
'   UserName                [ Optional ]            Default Value = vbNullString
'       Contains the username which has permission to access the secured resource
'
'   Password                [ Optional ]            Default Value = vbNullString
'       Contains the password which has permission to access the secured resource
'
On Error GoTo ErrHandler
Const HTTP_LEADER_CHARS = "HTTP://"
Const HTTPS_LEADER_CHARS = "HTTPS://"
Dim intPos1 As Integer, intPos2 As Integer
Dim lngPort As Long

    m_strExecContext = fGetExecContext("Connect")

    ' Check the handle for a valid value. If m_hInetSession is not initialized
    ' then call the InternetStart method with the default values for the arguments
    If (m_hInetSession = 0) Then Call Me.InternetStart
    
    ' if m_hConnect is valid then it means that the handle was not closed after
    ' a request made previously.
    If (m_hConnect) Then Call InternetCloseHandle(m_hConnect)
    
    intPos1 = InStr(1, URL, HTTP_LEADER_CHARS, vbTextCompare)
    intPos2 = InStr(1, URL, HTTPS_LEADER_CHARS, vbTextCompare)
    m_blnIsSecuredRequest = ((UseHTTPS) Or (intPos2))
    
    If (intPos1 = 0 And intPos2 = 0) Then
        If (m_blnIsSecuredRequest) Then
            URL = HTTPS_LEADER_CHARS & URL
        Else
            URL = HTTP_LEADER_CHARS & URL
        End If
    End If
    If (m_blnIsSecuredRequest) Then
        lngPort = INTERNET_DEFAULT_HTTPS_PORT
    Else
        lngPort = INTERNET_DEFAULT_HTTP_PORT
    End If
    
    ' Parse the specified URL into it's cannonicalized version
    If (fParseURL(m_tURLInfo, URL)) Then
        ' Make sure that the cannonicalized version contains a valid HostName
        m_blnIsErr = fAssertInetErr( _
                (Len(m_tURLInfo.lpszHostName) = 0), _
                m_strExecContext, _
                RaiseInternetAPIErrors)
    Else
        ' Unable to parse the specified URL. Raise error
        Err.Raise itlErrors.ITL_ERROR_UNKNOWN, m_strExecContext, _
            "Unknown error occurred while trying to connect to the specified location '" & URL & "'." & _
            vbCrLf & "Please verify that the URL is valid."
    End If
       
    m_hConnect = InternetConnect( _
                                m_hInetSession, _
                                m_tURLInfo.lpszHostName, _
                                lngPort, _
                                UserName, _
                                Password, _
                                INTERNET_SERVICE_HTTP, _
                                0, _
                                0)
                                
    ' Make sure that the handle is valid
    m_blnIsErr = fAssertInetErr( _
                            (m_hConnect = 0), _
                            m_strExecContext, _
                            RaiseInternetAPIErrors)
    
    m_blnHeaderSent = False
    Exit Sub
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Sub

Public Property Get WinInetVersion() As String
Attribute Connect.VB_Description = "Returns the version of WinInet.dll"
'
' Returns the version of WinInet.dll. This version can be used to determine
' the version of Internet Explorer installed on the system based on the values
' in the following table:
' Versions -
'       1.0 => Internet Explorer 3
'       1.1 => Internet Explorer 4
'       1.2 => Internet Explorer 5
'
On Error GoTo ErrHandler
Dim tDllInfo As ITL_INTERNET_VERSION_INFO

    m_strExecContext = fGetExecContext("WinInetVersion")

    ' Make sure that the handle returned is valid
    ' If the condition is true (InternetQueryOption returned zero)
    ' then the proc will raise an error
    m_blnIsErr = fAssertInetErr( _
        (InternetQueryOption(m_hInetSession, ITL_INTERNET_OPTION_VERSION, tDllInfo, Len(tDllInfo)) = 0), _
        m_strExecContext, RaiseInternetAPIErrors)
    
    ' Construct and return the version number
    With tDllInfo
        WinInetVersion = .dwMajorVersion & "." & .dwMinorVersion
    End With

    Exit Property
ErrHandler:
   With Err
       .Raise .Number, .source, .Description, .HelpFile, .HelpContext
   End With
End Property

Public Sub InternetStart( _
                        Optional AccessType As itlInternetOpenFlags = ITL_INTERNET_OPEN_TYPE_PRECONFIG, _
                        Optional ProxyName As String, _
                        Optional ProxyBypass As String, _
                        Optional Flags As itlOpenFlags = 0)
Attribute InternetStart.VB_Description = "Initializes the Win32 Internet functions so that they can be used from the class and the client"
'
' Initializes the Win32 Internet functions so that they can be
' used from the class and the client.
'
' Arguments:
'   AccessType               [ Optional ]           Default Value = ITL_INTERNET_OPEN_TYPE_PRECONFIG
'       Controls whether the client wishes to connect directly to the internet
'       or through a proxy. The default is ITL_INTERNET_OPEN_TYPE_PRECONFIG
'       which will retrieve the proxy or direct connection information from the registry.
'
'   ProxyName                [ Optional ]            Default Value = vbNullString
'        If AccessType is specified as ITL_INTERNET_OPEN_TYPE_PROXY, then
'        the ProxyName argument must contain the name of the proxy server.
'
'   ProxyBypass               [ Optional ]            Default Value = vbNullString
'       If AccessType is specified as ITL_INTERNET_OPEN_TYPE_PROXY, then
'       the ProxyBypass argument can contain an optional list of host names or
'       IP addresses, or both, that should not be routed through the proxy.
'       The list can contain wildcards.
'
'   Flags                         [ Optional ]            Default Value = 0
'       Flags that determine the behavior of the function.
'       ITL_INTERNET_FLAG_OFFLINE can be used if you wish to implement
'       offline browsing (disconnected mode)
'
On Error GoTo ErrHandler
Dim strUserAgent As String
    
    m_strExecContext = fGetExecContext("InternetStart")
   
    ' Notify the client of the attempt to connect
    RaiseEvent StatusChanged(LoadResString(ITL_STATUS_START_ATTEMPT))
    
    If (Len(m_strImpersonateBrowser)) Then
        strUserAgent = m_strImpersonateBrowser
    Else
        strUserAgent = LoadResString(ITL_USER_AGENT)
    End If
    
    m_hInetSession = InternetOpen( _
                                    strUserAgent, _
                                    AccessType, _
                                    ProxyName, _
                                    ProxyBypass, _
                                    Flags)
    
    ' Make sure that the handle returned is valid
    ' If (m_hInetSession=0), then the proc will raise an error
    m_blnIsErr = fAssertInetErr((m_hInetSession = 0), m_strExecContext, RaiseInternetAPIErrors)
    
    ' Notify the client of the connection success
    RaiseEvent StatusChanged(LoadResString(ITL_STATUS_START_SUCCESS))
    
   Exit Sub
ErrHandler:
   With Err
       .Raise .Number, .source, .Description, .HelpFile, .HelpContext
   End With
End Sub

Public Sub InternetStop()
Attribute InternetStop.VB_Description = "The method closes all open internet handles and releases other resources held internally"
'
' Called when then client is done using the class,
' the method closes all open internet handles
' and releases other resources held internally
'
On Error GoTo ErrHandler

    m_strExecContext = fGetExecContext("InternetStop")
    
    Call InternetCloseHandle(m_hReq)
    Call InternetCloseHandle(m_hConnect)
    Call InternetCloseHandle(m_hInetSession)
    Call InternetCloseHandle(m_hInetURL)

    m_hInetSession = 0
    m_hReq = 0
    m_hConnect = 0
    m_blnHeaderSent = False
    
    ' Notify the client
    RaiseEvent StatusChanged(LoadResString(ITL_STATUS_END))
    
    Exit Sub
ErrHandler:
   With Err
       .Raise .Number, .source, .Description, .HelpFile, .HelpContext
   End With
End Sub

Public Property Get HTTPPostHeaders() As String
Attribute HTTPPostHeaders.VB_Description = "Returns the header that needs to be appended to the request handle in order for a WWW server to process a POST operation correctly"
' Returns the header that needs to be appended to the
' request handle in order for a WWW server to process
' a POST operation correctly. For more information, refer to the
' following sources of information
'
' see section 8.2 in RFC 1866.
' http://www.ietf.org/rfc/rfc1866.txt
'
' Also check the following articles in the
' Microsoft Knowledge Base
' http://support.microsoft.com/default.aspx?scid=kb;en-us;Q165298
'
    HTTPPostHeaders = HTTP_POST_HEADER
End Property

Public Property Get Size() As Long
Attribute Size.VB_Description = "Returns the size, in bytes, of the document currently referenced"
' Returns the size, in bytes, of the document currently
' referenced
'
    Size = m_lngSize
End Property

Public Sub Disconnect()
Attribute Disconnect.VB_Description = "Cleanup"
'
' Cleanup
'
    Call Me.InternetStop
End Sub

Private Sub Class_Initialize()
    ' Set the RaiseInternetAPIErrors default to True
    ' so that the class raises errors if an API error
    ' occurs (for example, looking for a non-existant header
    ' in the response from the server)
    RaiseInternetAPIErrors = True
End Sub

Private Sub Class_Terminate()
'
' Cleanup
'
    On Error Resume Next
    Call Me.InternetStop
End Sub

Private Function fGetExecContext(strProcName As String, Optional blnRestoreParentProc As Boolean) As String
        fGetExecContext = CLS_NAME & strProcName
End Function
