VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "URLParts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

Private m_UrlInfo As ITL_URL_COMPONENTS
Private m_UrlInfoDummy As ITL_URL_COMPONENTS

Public Enum itlInternetSchemes
    ITL_INTERNET_SCHEME_PARTIAL = -2
    ITL_INTERNET_SCHEME_UNKNOWN = -1
    ITL_INTERNET_SCHEME_DEFAULT = 0
    ITL_INTERNET_SCHEME_FTP
    ITL_INTERNET_SCHEME_GOPHER
    ITL_INTERNET_SCHEME_HTTP
    ITL_INTERNET_SCHEME_HTTPS
    ITL_INTERNET_SCHEME_FILE
    ITL_INTERNET_SCHEME_NEWS
    ITL_INTERNET_SCHEME_MAILTO
    ITL_INTERNET_SCHEME_SOCKS
End Enum

Public Property Get SchemeName() As String
    SchemeName = m_UrlInfo.lpszScheme
End Property

Public Property Get SchemeType() As itlInternetSchemes
    SchemeType = m_UrlInfo.nScheme
End Property

Public Property Get HostName() As String
    HostName = m_UrlInfo.lpszHostName
End Property

Public Property Get Port() As Integer
    Port = m_UrlInfo.nPort
End Property

Public Property Get UserName() As String
    UserName = m_UrlInfo.lpszUserName
End Property

Public Property Get UrlPath() As String
    UrlPath = m_UrlInfo.lpszUrlPath
End Property

Public Property Get ExtraInfo() As String
    ExtraInfo = m_UrlInfo.lpszExtraInfo
End Property
  
Public Function Canonicalize2(ByVal URL As String, ByVal Flags As itlICUFlags) As Boolean
On Error GoTo ErrHandler
Dim lngLen As Long, strBuffer As String
Dim lngRet As Long, strURLLocal As String

    strBuffer = String$(MAX_BUFFER, 0)
    lngLen = Len(strBuffer)
    lngRet = InternetCanonicalizeUrl(URL, strBuffer, lngLen, Flags)
    If (lngRet) Then
        strURLLocal = Left$(strBuffer, lngLen)
        With m_UrlInfo
            .lpszScheme = String$(MAX_BUFFER, 0)
            .dwSchemeLength = MAX_BUFFER
            .nScheme = INTERNET_SCHEME_UNKNOWN
            .lpszHostName = String$(MAX_BUFFER, 0)
            .dwHostNameLength = MAX_BUFFER
            .nPort = 0
            .lpszUserName = String$(MAX_BUFFER, 0)
            .dwUserNameLength = MAX_BUFFER
            .lpszPassword = String$(MAX_BUFFER, 0)
            .dwPasswordLength = MAX_BUFFER
            .lpszUrlPath = String$(MAX_BUFFER, 0)
            .dwUrlPathLength = MAX_BUFFER
            .lpszExtraInfo = String$(MAX_BUFFER, 0)
            .dwExtraInfoLength = MAX_BUFFER
            .dwStructSize = Len(m_UrlInfo)
        End With
        lngRet = InternetCrackUrl(strURLLocal, Len(strURLLocal), _
                            ITL_ICU_ESCAPE, m_UrlInfo)
        If lngRet = 0 Then
            Canonicalize2 = False
        Else
            Canonicalize2 = True
            With m_UrlInfo
                .lpszExtraInfo = fTrimNull(.lpszExtraInfo)
                .lpszHostName = fTrimNull(.lpszHostName)
                .lpszPassword = fTrimNull(.lpszPassword)
                .lpszScheme = fTrimNull(.lpszScheme)
                .lpszUrlPath = fTrimNull(.lpszUrlPath)
                .lpszUserName = fTrimNull(.lpszUserName)
            End With
        End If
    End If
    
    If (Not Canonicalize2) Then
        LSet m_UrlInfo = m_UrlInfoDummy
    End If
    
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function


Public Function Canonicalize(ByVal URL As String, ByVal Flags As itlICUFlags) As Boolean
On Error GoTo ErrHandler
Dim lngLen As Long, strBuffer As String
Dim lngRet As Long, strURLLocal As String

    strBuffer = String$(MAX_BUFFER, 0)
    lngLen = Len(strBuffer)
    lngRet = InternetCanonicalizeUrl(URL, strBuffer, lngLen, Flags)
    If (lngRet) Then
        strURLLocal = Left$(strBuffer, lngLen)
        With m_UrlInfo
            .lpszScheme = String$(MAX_BUFFER, 0)
            .dwSchemeLength = MAX_BUFFER
            .nScheme = INTERNET_SCHEME_UNKNOWN
            .lpszHostName = String$(MAX_BUFFER, 0)
            .dwHostNameLength = MAX_BUFFER
            .nPort = 0
            .lpszUserName = String$(MAX_BUFFER, 0)
            .dwUserNameLength = MAX_BUFFER
            .lpszPassword = String$(MAX_BUFFER, 0)
            .dwPasswordLength = MAX_BUFFER
            .lpszUrlPath = String$(MAX_BUFFER, 0)
            .dwUrlPathLength = MAX_BUFFER
            .lpszExtraInfo = String$(MAX_BUFFER, 0)
            .dwExtraInfoLength = MAX_BUFFER
            .dwStructSize = Len(m_UrlInfo)
        End With
        lngRet = InternetCrackUrl(strURLLocal, Len(strURLLocal), _
                            ITL_ICU_ESCAPE, m_UrlInfo)
        If lngRet = 0 Then
            Canonicalize = False
        Else
            Canonicalize = True
            With m_UrlInfo
                .lpszExtraInfo = fTrimNull(.lpszExtraInfo)
                .lpszHostName = fTrimNull(.lpszHostName)
                .lpszPassword = fTrimNull(.lpszPassword)
                .lpszScheme = fTrimNull(.lpszScheme)
                .lpszUrlPath = fTrimNull(.lpszUrlPath)
                .lpszUserName = fTrimNull(.lpszUserName)
            End With
        End If
    End If
    
    If (Not Canonicalize) Then
        LSet m_UrlInfo = m_UrlInfoDummy
    End If
    
    Exit Function
ErrHandler:
    With Err
        .Raise .Number, .source, .Description, .HelpFile, .HelpContext
    End With
End Function

