Attribute VB_Name = "modDeclares"
Option Explicit
Option Private Module

'
'  Copyright  1998-2002 Dev Ashish & Terry Kreft, All Rights Reserved
'  The Access Web       [ http://www.mvps.org/access ]
'  Terms of Use:           [ http://www.mvps.org/access/terms.htm ]
'  Dev Ashish (dev@mvps.org) ; Terry Kreft (terry.kreft@mps.co.uk)
'

Public Type REQUEST_CONTEXT
    pStatus As Long
    pTag As Long
End Type

Public Type ITL_INTERNET_VERSION_INFO
    dwMajorVersion As Long
    dwMinorVersion As Long
End Type

Public Type ITL_URL_COMPONENTS
  dwStructSize As Long
  lpszScheme As String
  dwSchemeLength As Long
  nScheme As Long
  lpszHostName As String
  dwHostNameLength As Long
  nPort As Long
  lpszUserName As String
  dwUserNameLength As Long
  lpszPassword As String
  dwPasswordLength As Long
  lpszUrlPath As String
  dwUrlPathLength As Long
  lpszExtraInfo As String
  dwExtraInfoLength As Long
End Type

Public Type INTERNET_BUFFERS
    dwStructSize As Long
    dwNext As Long
    lpcszHeader As String
    dwHeadersLength As Long
    dwHeadersTotal As Long
    lpvBuffer As Long
    dwBufferLength As Long
    dwBufferTotal As Long
    dwOffsetLow  As Long
    dwOffsetHigh  As Long
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * 260
    cAlternate As String * 16
End Type

Public Enum RES_STRINGS
    ITL_USER_AGENT = 1
    ITL_STATUS_START_ATTEMPT = 2
    ITL_STATUS_START_SUCCESS = 3
    ITL_STATUS_END = 4
    ITL_FORCE_RETRY = 5
End Enum

Public Const FTP_TRANSFER_TYPE_UNKNOWN = &H0
Public Const FTP_TRANSFER_TYPE_ASCII = &H1
Public Const FTP_TRANSFER_TYPE_BINARY = &H2
Public Const FTP_TRANSFER_TYPE_MASK = (FTP_TRANSFER_TYPE_ASCII Or FTP_TRANSFER_TYPE_BINARY)

Public Const HTTP_QUERY_FLAG_REQUEST_HEADERS = &H80000000
Public Const HTTP_QUERY_STATUS_CODE = 19
Public Const HTTP_QUERY_STATUS_TEXT = 20

Public Const MAX_CHUNK = 4096
Public Const MAX_CHUNK_SMALL = 1024
Public Const MAX_PATH = 260
Public Const MAX_BUFFER = 1024

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const OPEN_EXISTING = 3
Public Const CREATE_ALWAYS = 2
Public Const INVALID_HANDLE_VALUE = -1
Public Const FILE_ATTRIBUTE_NORMAL = &H80

Public Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Public Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200&
Public Const FORMAT_MESSAGE_FROM_HMODULE = &H800&
Public Const FORMAT_MESSAGE_MAX_WIDTH_MASK = &HFF

Public Const INTERNET_CONNECTION_MODEM = 1
Public Const INTERNET_CONNECTION_LAN = 2
Public Const INTERNET_CONNECTION_PROXY = 4
Public Const INTERNET_CONNECTION_MODEM_BUSY = 8

Public Const INTERNET_AUTODIAL_FORCE_ONLINE = 1
Public Const INTERNET_AUTODIAL_FORCE_UNATTENDED = 2


Public Const INTERNET_SCHEME_UNKNOWN = -1

Public Const INTERNET_INVALID_PORT_NUMBER = 0
Public Const INTERNET_DEFAULT_HTTP_PORT = 80
Public Const INTERNET_DEFAULT_HTTPS_PORT = 443
Public Const INTERNET_SERVICE_FTP = 1
Public Const INTERNET_SERVICE_GOPHER = 2
Public Const INTERNET_SERVICE_HTTP = 3

Public Const INTERNET_ERROR_BASE = 12000

Public Const ERROR_BAD_PATHNAME = 161
Public Const ERROR_INVALID_PARAMETER = &H87
Public Const ERROR_INTERNET_INVALID_URL = (INTERNET_ERROR_BASE + 5)
Public Const ERROR_INSUFFICIENT_BUFFER = 122

Public Const ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR = (INTERNET_ERROR_BASE + 39)
Public Const ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR = (INTERNET_ERROR_BASE + 40)
Public Const ERROR_INTERNET_INCORRECT_PASSWORD = (INTERNET_ERROR_BASE + 14)
Public Const ERROR_ERROR_INTERNET_INVALID_CA = (INTERNET_ERROR_BASE + 45)
Public Const ERROR_INTERNET_POST_IS_NON_SECURE = (INTERNET_ERROR_BASE + 43)
Public Const ERROR_INTERNET_SEC_CERT_DATE_INVALID = (INTERNET_ERROR_BASE + 37)
Public Const ERROR_INTERNET_SEC_CERT_CN_INVALID = (INTERNET_ERROR_BASE + 38)

Public Const FLAGS_ERROR_UI_FILTER_FOR_ERRORS = &H1
Public Const FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS = &H2
Public Const FLAGS_ERROR_UI_FLAGS_GENERATE_DATA = &H4
Public Const FLAGS_ERROR_UI_FLAGS_NO_UI = &H8
Public Const FLAGS_ERROR_UI_SERIALIZE_DIALOGS = &H10

' see section 8.2 in RFC 1866.
' http://www.ietf.org/rfc/rfc1866.txt
'
Public Const HTTP_POST_HEADER = "Content-Type: application/x-www-form-urlencoded"

Public Const ERROR_NO_MORE_FILES = 18

Public Const LOAD_LIBRARY_AS_DATAFILE = 2&

Public Const HTTP_VERSION = "HTTP/1.0"
Public Const HTTP_VERB_GET = "GET"
Public Const HTTP_VERB_POST = "POST"
Public Const HTTP_VERB_PUT = "PUT"

Public Const HTTP_CONTENT_TYPE_TEXT_LEADER_CHARS = "text/"

Public Const WININET_API_FLAG_ASYNC = &H1                ' // force async operation
Public Const WININET_API_FLAG_SYNC = &H4                  '// force sync operation
Public Const WININET_API_FLAG_USE_CONTEXT = &H8
Public Const HSR_USE_CONTEXT = WININET_API_FLAG_USE_CONTEXT  ' // use dwContext value
Public Const HSR_INITIATE = &H8                              ' // iterative operation (completed by HttpEndRequest)
Public Const HSR_DOWNLOAD = &H10                             '  // download to file
Public Const HSR_CHUNKED = &H20                                ' // operation is send of chunked data
Public Const MAXDWORD = &HFFFFFFFF
Public Const USERAGENT_IE = "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)"

Public Const DECIMAL_FORMAT = "##.##"
Public Const ALL_FILES_FORMAT = "Accept: */*"

Public Declare Function FormatMsgLong _
    Lib "kernel32" Alias "FormatMessageA" _
    (ByVal dwFlags As Long, _
    ByVal lpSource As Long, _
    ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, _
    ByVal nSize As Long, _
    Arguments As Long) _
    As Long
    
Public Declare Function HttpOpenRequest _
    Lib "WinInet.dll" Alias "HttpOpenRequestA" _
    (ByVal hConnect As Long, _
    ByVal lpszVerb As String, _
    ByVal lpszObjectName As String, _
    ByVal lpszVersion As String, _
    ByVal lpszReferer As String, _
    ByVal lpszAcceptTypes As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
Public Declare Function InternetCrackUrl _
    Lib "WinInet.dll" Alias "InternetCrackUrlA" _
    (ByVal lpszUrl As String, _
    ByVal dwUrlLength As Long, _
    ByVal dwFlags As Long, _
    lpUrlComponents As ITL_URL_COMPONENTS) _
    As Long

Public Declare Function InternetCanonicalizeUrl _
    Lib "WinInet.dll" Alias "InternetCanonicalizeUrlA" _
    (ByVal lpszUrl As String, _
    ByVal lpszBuffer As String, _
    lpdwBufferLength As Long, _
    ByVal dwFlags As Long) _
    As Long

Public Declare Function InternetGetConnectedState _
    Lib "WinInet.dll" _
    (ByVal lpdwFlags As Long, _
    ByVal dwReserved As Long) _
    As Long
  
Public Declare Function InternetReadFile _
    Lib "WinInet.dll" _
    (ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal dwBytesToRead As Long, _
    lpBytesRead As Long) _
    As Long
    
Public Declare Function InternetOpenURL _
    Lib "WinInet.dll" Alias "InternetOpenUrlA" _
    (ByVal hInternet As Long, _
    ByVal lpszUrl As String, _
    ByVal lpszHeaders As String, _
    ByVal dwHeadersLength As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
  
Public Declare Function InternetOpen _
    Lib "WinInet.dll" Alias "InternetOpenA" _
    (ByVal lpszAgent As String, _
    ByVal dwAccessType As Long, _
    ByVal lpszProxy As String, _
    ByVal lpszProxyBypass As String, _
    ByVal dwFlags As Long) _
    As Long
  
Public Declare Function HttpSendRequestEx _
    Lib "WinInet.dll" Alias "HttpSendRequestExA" _
    (ByVal hRequest As Long, _
    lpBuffersIn As Any, _
    lpBuffersOut As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long

Public Declare Function InternetCloseHandle _
    Lib "WinInet.dll" _
    (ByVal hInternet As Long) _
    As Long
  
Public Declare Function InternetQueryDataAvailable _
    Lib "WinInet.dll" _
    (ByVal hFile As Long, _
    lpdwNumberOfBytesAvailable As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
Public Declare Function InternetSetStatusCallback _
    Lib "WinInet.dll" Alias "InternetSetStatusCallbackA" _
    (ByVal hInternet As Long, _
    ByVal lpfnInternetCallback As Long) _
    As Long
    

Public Declare Function HttpQueryInfo _
    Lib "WinInet.dll" Alias "HttpQueryInfoA" _
    (ByVal hHttpRequest As Long, _
    ByVal dwInfoLevel As Long, _
    lpvBuffer As Any, _
    lpdwBufferLength As Long, _
    lpdwIndex As Long) _
    As Long
    
Public Declare Function HttpAddRequestHeaders _
    Lib "WinInet.dll" Alias "HttpAddRequestHeadersA" _
    (ByVal hConnect As Long, _
    ByVal lpszHeaders As String, _
    ByVal dwHeadersLength As Long, _
    ByVal dwModifiers As Long) _
    As Long
  
Public Declare Function HttpSendRequest _
    Lib "WinInet.dll" Alias "HttpSendRequestA" _
    (ByVal hRequest As Long, _
    ByVal lpszHeaders As String, _
    ByVal dwHeadersLength As Long, _
    lpOptional As Any, _
    ByVal dwOptionalLength As Long) _
    As Long
    
Public Declare Function HttpEndRequest _
    Lib "WinInet.dll" Alias "HttpEndRequestA" _
    (ByVal hRequest As Long, _
    lpBuffersOut As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
  
Public Declare Function InternetGetLastResponse _
    Lib "WinInet.dll" Alias "InternetGetLastResponseInfoA" _
    (lpdwError As Long, _
    ByVal lpszBuffer As String, _
    lpdwBufferLength As Long) _
    As Long

Public Declare Function InternetConnect _
    Lib "WinInet.dll" Alias "InternetConnectA" _
    (ByVal hInternet As Long, _
    ByVal lpszServerName As String, _
    ByVal nServerPort As Integer, _
    ByVal lpszUserName As String, _
    ByVal lpszPassword As String, _
    ByVal dwService As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
Public Declare Function InternetQueryOption _
    Lib "WinInet.dll" Alias "InternetQueryOptionA" _
    (ByVal hInternet As Long, _
    ByVal dwOption As Long, _
    lpBuffer As Any, _
    ByRef lpdwBufferLength As Long) _
    As Long
  
Public Declare Function InternetWriteFile _
    Lib "WinInet.dll" _
    (ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal dwNumberOfBytesToWrite As Long, _
    lpdwNumberOfBytesWritten As Long) _
    As Long

Public Declare Function InternetAutodial _
    Lib "WinInet.dll" _
    (ByVal dwFlags As Long, _
    ByVal dwReserved As Long) _
    As Long
  
Public Declare Function CreateFile _
    Lib "kernel32.dll" Alias "CreateFileA" _
    (ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    ByVal lpSecurityAttributes As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) _
    As Long
  
Public Declare Function FtpRenameFile _
    Lib "WinInet.dll" Alias "FtpRenameFileA" _
    (ByVal hConnect As Long, _
    ByVal lpszExisting As Long, _
    ByVal lpszNew As String) _
    As Long
  
Public Declare Function FtpOpenFile _
    Lib "WinInet.dll" Alias "FtpOpenFileA" _
    (ByVal hFtpSession As Long, _
    ByVal lpszFileName As String, _
    ByVal fdwAccess As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long

Public Declare Function FtpCreateDirectory _
    Lib "wininet" Alias "FtpCreateDirectoryA" _
    (ByVal hFtpSession As Long, _
    ByVal lpszDirectory As String) _
    As Long
  
Public Declare Function FtpSetCurrentDirectory _
    Lib "wininet" Alias "FtpSetCurrentDirectoryA" _
    (ByVal hFtpSession As Long, _
    ByVal lpszDirectory As String) _
    As Long

Public Declare Function FtpGetCurrentDirectory _
    Lib "WinInet.dll" Alias "FtpGetCurrentDirectoryA" _
    (ByVal hConnect As Long, _
    ByVal lpszCurrentDirectory As String, _
    lpdwCurrentDirectory As Long) _
    As Long

Public Declare Function FTPPutFile _
    Lib "WinInet.dll" Alias "FtpPutFileA" _
    (ByVal hFtpSession As Long, _
    ByVal lpszLocalFile As String, _
    ByVal lpszNewRemoteFile As String, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
Public Declare Function FtpGetFile _
    Lib "WinInet.dll" _
    (ByVal hConnect As Long, _
    ByVal lpszRemoteFile As String, _
    ByVal lpszNewFile As String, _
    ByVal fFailIfExists As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long

Public Declare Function FtpFindFirstFile _
    Lib "WinInet.dll" Alias "FtpFindFirstFileA" _
    (ByVal hConnect As Long, _
    ByVal lpszSearchFile As String, _
    lpFindFileData As WIN32_FIND_DATA, _
    ByVal dwFlags As Long, _
    ByVal dwContext As Long) _
    As Long
    
Public Declare Function LoadLibraryEx _
    Lib "kernel32" Alias "LoadLibraryExA" _
    (ByVal lpLibFileName As String, _
    ByVal hFile As Long, _
    ByVal dwFlags As Long) _
    As Long
  
Public Declare Function WriteFile _
    Lib "kernel32.dll" _
    (ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, _
    ByVal lpOverlapped As Long) _
    As Long

Public Declare Function ReadFile _
    Lib "kernel32" _
    (ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, _
    ByVal lpOverlapped As Long) _
    As Long
         
Public Declare Function FlushFileBuffers _
    Lib "kernel32.dll" _
    (ByVal hFile As Long) _
    As Long
  
Public Declare Function CloseHandle _
    Lib "kernel32.dll" _
    (ByVal hObject As Long) _
    As Long

Public Declare Function GetActiveWindow _
    Lib "user32" () _
    As Long

Public Declare Function FreeLibrary _
    Lib "kernel32" _
    (ByVal hLibModule As Long) _
    As Long

Public Declare Function GetFileSize _
    Lib "kernel32" _
    (ByVal hFile As Long, _
    lpFileSizeHigh As Long) _
    As Long

Public Declare Sub CopyMem _
    Lib "kernel32" Alias "RtlMoveMemory" _
    (Destination As Any, _
    source As Any, _
    ByVal Length As Long)

Public Declare Sub ZeroMem _
    Lib "kernel32" Alias "RtlZeroMemory" _
    (Destination As Any, _
    ByVal Length As Long)

Public Declare Function InternetFindNextFile _
    Lib "WinInet.dll" Alias "InternetFindNextFileA" _
    (ByVal hFind As Long, _
    lpvFindData As Any) _
    As Long

Public Declare Function FtpDeleteFile _
    Lib "WinInet.dll" Alias "FtpDeleteFileA" _
    (ByVal hConnect As Long, _
    ByVal lpszFileName As String) _
    As Long

Public Declare Function GetForegroundWindow _
    Lib "user32" () _
    As Long
    
Public Declare Function InternetSetOption _
    Lib "WinInet.dll" Alias "InternetSetOptionA" _
    (ByVal hInternet As Long, _
    ByVal dwOption As Long, _
    lpBuffer As Any, _
    ByVal dwBufferLength As Long) _
    As Long

Public Declare Function GetDesktopWindow _
    Lib "user32" () _
    As Long

Public Declare Function InternetErrorDlg _
    Lib "WinInet.dll" _
    (ByVal hWnd As Long, _
    ByVal hInternet As Long, _
    ByVal dwError As Long, _
    ByVal dwFlags As Long, _
    lppvData As Long) _
    As Long
    

